import java.util.*;
import java.lang.Math;


public class AttributeRelevance
{

String[][] stav;
String[][][] frekvence;
int kolikRadku;
double[] relevance; 


    public AttributeRelevance()
    {
    }


public void spocitejAtribut(String[][] stavData, String[][][] freq, int radky, int sloupec, String jmenoSloupce, int pocetHodnotVybranehoAtributu, int pocetHodnotCilovehoAtributu, int cil) {

stav = stavData;
frekvence = freq;
kolikRadku = radky;
int y = sloupec;

relevance = new double[4];

double sumaSloupce[] = new double[kolikRadku+1];
double sumaRadky[] = new double[kolikRadku+1];
double sumaCelkem = 0;
int delkaAtributu = pocetHodnotVybranehoAtributu;
int delkaCilovehoAtributu = pocetHodnotCilovehoAtributu;
double[][] conti = new double[delkaAtributu+1][delkaCilovehoAtributu+1];


for (int a = 1; a <= delkaAtributu; a++) {
for (int b = 1; b <= delkaCilovehoAtributu; b++) {
for (int x = 1; x <= kolikRadku; x++) {

if (stav[x][y].equals(frekvence[a][y][1]) && stav[x][cil].equals(frekvence[b][cil][1])) {
conti[a][b] = conti[a][b] + 1;

} // if

}
}
} // for x

// vypocet radkovych a sloupcovych souctu

for (int a = 1; a <= delkaAtributu; a++) {
for (int b = 1; b <= delkaCilovehoAtributu; b++) {
sumaRadky[a] = sumaRadky[a] + conti[a][b];
sumaSloupce[b] = sumaSloupce[b] + conti[a][b];
sumaCelkem = sumaCelkem + conti[a][b];
}
}

// vypocet chi
for (int a = 1; a <= delkaAtributu; a++) {
for (int b = 1; b <= delkaCilovehoAtributu; b++) {
relevance[1] = relevance[1] + ((conti[a][b] - ((sumaRadky[a] * sumaSloupce[b]) / sumaCelkem)) * (conti[a][b] - ((sumaRadky[a] * sumaSloupce[b]) / sumaCelkem)))  / ((sumaRadky[a] * sumaSloupce[b]));

}
}
relevance[1] = (double)Math.round(relevance[1] * sumaCelkem *100) /100;


//entropy 
double entropyPart[] = new double[delkaAtributu + 1];
double entropy = 0;
for (int a = 1; a <= delkaAtributu; a++) {
entropyPart[a] = 0;
int b = 1; 
while (b <= delkaCilovehoAtributu) {

entropyPart[a] = entropyPart[a] + ((conti[a][b] / sumaRadky[a]) * Math.log10(conti[a][b] / sumaRadky[a]));
b++;
}
entropyPart[a] = -entropyPart[a];

}
for (int a = 1; a <= delkaAtributu; a++) {
entropy = entropy + ((sumaRadky[a] / sumaCelkem) *  entropyPart[a]);
entropyPart[a] = 0;
}
relevance[2] = (double)Math.round(entropy *100) /100;
entropy = 0;


// mutual information

double MI = 0;
double IMDPart = 0;
double IMD = 0;
for (int b = 1; b <= delkaCilovehoAtributu; b++) {
for (int a = 1; a <= delkaAtributu; a++) {
MI = MI + (conti[a][b] * Math.log10((sumaCelkem * conti[a][b])/ (sumaRadky[a] * sumaSloupce[b]) ));
}
IMDPart = IMDPart + (sumaSloupce[b] / sumaCelkem) * Math.log10(sumaSloupce[b] / sumaCelkem);
}
IMD = (((-1 / sumaCelkem) * MI) / (- IMDPart)); 
relevance[3] = (double)Math.round(IMD *100) /100;



// tisk
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + "Kontingencni tabulka pro atribut " + jmenoSloupce );
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" +  "Hodnoty ciloveho atributu: " + "\t");
for (int t = 1; t<=delkaCilovehoAtributu; t++) { 
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + " " + frekvence[t][cil][1] + "\t" );
}
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + "Celkem" + "\n");

for (int a = 1; a <= delkaAtributu; a++) {
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() +  " hodnota " + frekvence[a][y][1] + " : "  + "\t"  + "\t");
for (int b = 1; b <= delkaCilovehoAtributu; b++) {
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() +  " " + conti[a][b] + "\t" );
}
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() +  " " + sumaRadky[a]);
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() +  "\n"  );
}
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() +  "Celkem: " +  "\t"  +  "\t");
for (int b = 1; b <= delkaCilovehoAtributu; b++) {
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() +  " " + sumaSloupce[b] + "\t" );
}
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() +  " " + sumaCelkem + "\t" );
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + "Relevance Chi: " + relevance[1] + " Entropy: " + relevance[2] + " MI: " + relevance[3]);
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + " * * * * * ");




} // spocitejAtribut


} // class
