import java.util.*;
import java.io.*;

/**
 * Tda potajc zvislost dvou atribut.
 */

public class AttributeDependence
{
    public AttributeDependence()
    {
    }
DataKapsa datoveStruktury;

private double maxVysledek;
private TreeMap<String, Double> maxMap;

/**
 * Metoda vrac nejvy vsledek
 * 
 */

public double getMaxVysledek () {
return maxVysledek;
}

/**
 * Metoda vrac mapu s vsledky
 * 
 */
public TreeMap getMaxMap () {
return maxMap;
}

/**
 * Metoda nastavuje poten hodnotu pro maximln vsledek a vytv mapu pro vsledky
 * 
 */
public void init() {
maxVysledek = Double.MIN_VALUE;
maxMap = new TreeMap<String, Double>();

}

/**
 * Metoda potajc zvislost dvou atribut.
 * @param sloupec1 
 * @param sloupec2
 * @param doMapy retezec s vysledkem
 */


public void dependence(int sloupec1, int sloupec2, String doMapy) {
datoveStruktury = datoveStruktury.getInstance();

int radekADvysledku = 1;
int pocetHodnotSloupec1 = datoveStruktury.pocetHodnotAtributu[sloupec1]; 
int pocetHodnotSloupec2 = datoveStruktury.pocetHodnotAtributu[sloupec2]; 
String poleKombinaci[][] = new String [(pocetHodnotSloupec1 * pocetHodnotSloupec2) + 1][8];

int cisloRadku = 0;
for (int a = 1; a<= pocetHodnotSloupec1; a++) {
for (int b = 1; b<= pocetHodnotSloupec2; b++) {
cisloRadku++;
poleKombinaci[cisloRadku][1] = "" + datoveStruktury.frekvence[a][sloupec1][1];
poleKombinaci[cisloRadku][2] = "" + datoveStruktury.frekvence[b][sloupec2][1];
poleKombinaci[cisloRadku][3] = "" + poleKombinaci[cisloRadku][1] + ";" + poleKombinaci[cisloRadku][2];
poleKombinaci[cisloRadku][4] = "" + datoveStruktury.frekvence[a][sloupec1][2];
poleKombinaci[cisloRadku][5] = "" + datoveStruktury.frekvence[b][sloupec2][2];
poleKombinaci[cisloRadku][6] = "0";
} // for b
} // for a

int pocetRadkuKombinaci = cisloRadku;
cisloRadku = 1;

for (int c = 1; c<= datoveStruktury.pocetRadkuSouboru; c++) {
for (int d = 1; d<= pocetRadkuKombinaci; d++) {
if ((datoveStruktury.stavData[c][sloupec1]).equals(poleKombinaci[d][1]) && (datoveStruktury.stavData[c][sloupec2]).equals(poleKombinaci[d][2])) {
if (datoveStruktury.vybranaVaha == 0) {
poleKombinaci[d][6] = (Double.parseDouble(poleKombinaci[d][6]) + 1) + ""; 
}
else {
poleKombinaci[d][6] = (Double.parseDouble(poleKombinaci[d][6]) + Double.parseDouble(datoveStruktury.stavData[c][datoveStruktury.vybranaVaha])) + ""; 
}
}

} // for d
} // for c

HashMap<String, String> mapa = new HashMap<String, String>();
for (int f = 1; f<= pocetRadkuKombinaci; f++) {
String komb = poleKombinaci[f][3];
String freq = poleKombinaci[f][6];
if (!poleKombinaci[f][6].equals("0")) {
mapa.put(komb, freq);
}
} // for f

String pouziteKombinace[][] = new String [mapa.size() + 1][8];
cisloRadku = 1;
Set<Map.Entry<String,String>> mnozinaDvojic = mapa.entrySet(); 
for(Map.Entry <String, String> dvojice : mnozinaDvojic) {

pouziteKombinace[cisloRadku][3] = dvojice.getKey();
pouziteKombinace[cisloRadku][6] = dvojice.getValue();

cisloRadku++;

}

int pouzitychKombinaci = cisloRadku;

for (int g = 1; g< pouzitychKombinaci; g++) {
for (int f = 1; f<= pocetRadkuKombinaci; f++) {
if (pouziteKombinace[g][3].equals(poleKombinaci[f][3])) {
pouziteKombinace[g][1] = poleKombinaci[f][1];
pouziteKombinace[g][2] = poleKombinaci[f][2];
pouziteKombinace[g][4] = poleKombinaci[f][4];
pouziteKombinace[g][5] = poleKombinaci[f][5];
break;
}
}
}

double vysledek = 0;

for (int g = 1; g< pouzitychKombinaci; g++) {

double komb4 = Double.parseDouble(pouziteKombinace[g][4]);
double komb5 = Double.parseDouble(pouziteKombinace[g][5]);
double komb6 = Double.parseDouble(pouziteKombinace[g][6]);
vysledek = vysledek + (komb6 * Math.log(komb6/komb4)) + (komb6 * Math.log(komb6/komb5));
}
vysledek = Math.round((-1) * vysledek * 100) / 100;
if (maxVysledek < vysledek) {
maxVysledek = vysledek;

}

maxMap.put(doMapy,  vysledek);



Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText()  + " \n " + doMapy + vysledek);
}// dependence
}// class
