import java.util.*;
import javax.swing.JOptionPane;
import javax.swing.*;

/**
 * Tda zajiujc zkladn statistick popis dat. Zjiuje absolutn i relativn frekvenci hodnot, minimum, maximum, prmr,
 * smrodatnou odchylku a modus u numerickch hodnot
 */

public class DataDescription
{

private String[][][] frekvence;
private double[][] vysledkyPopisStat;
private String[] hodnotyModus;
private int [] pocetHodnot;
private String [][] stav;
private double sumaVah;

     public DataDescription()
    {
    }

public double getSumaVah() {
return sumaVah;
}    

/**
 * Data ze vstupnho souboru
 */    
public String[][] getStavData() {
return stav;
}
    
public String[][][] getFrekvence() {
return frekvence;
}
    
public double[][] getVysledkyPopisStat() {
return vysledkyPopisStat;
}

public int[] getPocetHodnotAtributu() {
return pocetHodnot;
}

public String[] getHodnotyModus() {
return hodnotyModus;
}

/**
 * Metoda zajiujc zkladn statistick popis dat. Zjiuje absolutn i relativn frekvenci hodnot, minimum, maximum, prmr,
 * smrodatnou odchylku a modus u numerickch hodnot
 */

public void popis(String[][] data, int radky, int sloupce, int vaha1, String[][] typAtributu1 ) {
stav = data;
int kolikRadku = radky;
int kolikSloupcu = sloupce;
int vaha = vaha1;
String [][] typAtributu = typAtributu1;
vysledkyPopisStat = new double [6][kolikSloupcu + 1];
hodnotyModus = new String[kolikSloupcu +1];
pocetHodnot = new int [sloupce + 1];


/****************************************************************************************************************
 *v tuto chvili je urceno, ktery sloupec obsahuje vahu 
 *
 *  Pole frekvence: 

 *  patro [][][1] obsahuje: hodnoty 
 *  patro [][][2] obsahuje: cetnosti
 *  patro [][][3] obsahuje: rel. cetnosti

*/
frekvence = new String[kolikRadku+1][kolikSloupcu+1][6];
for (int x = 0; x <= kolikRadku; x++) {
for (int y = 0; y <= kolikSloupcu; y++) {
frekvence[x][y][0]= "";
frekvence[x][y][1]= "";
frekvence[x][y][2]= "";
frekvence[x][y][3]= "";
frekvence[x][y][4]= "";
frekvence[x][y][5]= "";
}
}

int x = 1;
int y = 1;
while (y <= kolikSloupcu) {
if (typAtributu[2][y].equals("cislo")) {
Map<Double, Double> m = new TreeMap<Double, Double>();
for (x = 2; x <= kolikRadku; x++) {
if (!stav[x][y].equals("")) { 
Double a = Double.parseDouble(stav[x][y]);
stav[x][y] = "" + a;
Double freq = m.get(a);
if ((vaha == 0) || (y == vaha)) {
m.put(a, (freq == null) ? 1 : freq + 1);
}
else {
m.put(a, (freq == null) ? Double.parseDouble(stav[x][vaha]) : freq + Double.parseDouble(stav[x][vaha]));
}
}

}

double soucetFrekvenci = 0;
int w = 1;
Set<Map.Entry<Double,Double>> mnozinaDvojic = m.entrySet(); 
for(Map.Entry <Double, Double> dvojice : mnozinaDvojic) { 
frekvence[w][y][1] = "" + dvojice.getKey();
frekvence[w][y][2] = "" + dvojice.getValue().toString();

if (!frekvence[0][y][2].equals("")) {
soucetFrekvenci = Double.parseDouble(frekvence[0][y][2]) + Double.parseDouble(frekvence[w][y][2]);
}
else
{
soucetFrekvenci = Double.parseDouble(frekvence[w][y][2]);
}

frekvence[0][y][2] = "" + soucetFrekvenci;

w++;
} // for Map.Entry
pocetHodnot[y] = m.size();
m.clear();
y++;

}
else { // if typAtributu je text
Map<String, Double> m = new TreeMap<String, Double>();
for (x = 2; x <= kolikRadku; x++) {
if (!stav[x][y].equals("")) { 
String a = stav[x][y];
Double freq = m.get(a);
if (vaha == 0 || y == vaha) {
m.put(a, (freq == null) ? 1 : freq + 1);
}
else {
m.put(a, (freq == null) ? Double.parseDouble(stav[x][vaha]) : freq + Double.parseDouble(stav[x][vaha]));
}
}

}

double soucetFrekvenci = 0;
int w = 1;
Set<Map.Entry<String,Double>> mnozinaDvojic = m.entrySet(); 
for(Map.Entry <String, Double> dvojice : mnozinaDvojic) { 
frekvence[w][y][1] = dvojice.getKey();
frekvence[w][y][2] = dvojice.getValue().toString();

if (!frekvence[0][y][2].equals("")) {
soucetFrekvenci = Double.parseDouble(frekvence[0][y][2]) + Double.parseDouble(frekvence[w][y][2]);
}
else
{
soucetFrekvenci = Double.parseDouble(frekvence[w][y][2]);
}

frekvence[0][y][2] = "" + soucetFrekvenci;

w++;
} // for Map.Entry
pocetHodnot[y] = m.size();
m.clear();
y++;
}

} // while

double relCetnost = 0;

for (y = 1; y <= kolikSloupcu; y++ ) {
for (x = 1; x <= kolikRadku; x++ ) {
if (!frekvence[x][y][2].equals("")) {
relCetnost = Double.parseDouble(frekvence[x][y][2])/Double.parseDouble(frekvence[0][y][2]);
frekvence[x][y][3] = "" + ((double)Math.round(relCetnost * 100) / 100);
}
}
}


double min = Double.MAX_VALUE;
double max = Double.MIN_VALUE;
double soucet = 0;
double prumer = 0;
double delitelPrumeru = 1;
double hodnota;
double hodnotaVahy = 0;

for (y = 1; y <= kolikSloupcu; y++) {
for (x = 2; x <= kolikRadku; x++) {
if (!stav[x][y].equals("") && typAtributu[2][y].equals("cislo")) {
if (x == 2) {
min = Double.parseDouble(stav[x][y]);
max = Double.parseDouble(stav[x][y]);
}

hodnota = Double.parseDouble(stav[x][y]);
if (vaha > 0) {
hodnotaVahy = Double.parseDouble(stav[x][vaha]);
}

if (min > hodnota) {
min = hodnota;
}
if (max < hodnota) {
max = hodnota;
}

if ((vaha > 0) && (y != vaha)) {
soucet = soucet + (hodnota * hodnotaVahy);
delitelPrumeru = delitelPrumeru + hodnotaVahy;
}
else {
soucet = soucet + hodnota;
delitelPrumeru++;
}

} // if !stav = ""
if (typAtributu[2][y].equals("text")) {
min = 0;
max = 0;
soucet = 0;
prumer = 0;
delitelPrumeru = 1;

}
} // for x
prumer = soucet / (delitelPrumeru-1);
if (y == vaha) {
sumaVah = soucet;
}
vysledkyPopisStat[1][y] = min;
vysledkyPopisStat[2][y] = max;
vysledkyPopisStat[3][y] = (double)Math.round(prumer * 100)/100;
min = Double.MAX_VALUE;
max = Double.MIN_VALUE;
soucet = 0;
prumer = 0;
delitelPrumeru = 1;

} // for y




double sumaSmoch = 0;
double delitelSmoch = 1;
for (y = 1; y <= kolikSloupcu; y++) {
for (x = 2; x <= kolikRadku; x++) {
if (!stav[x][y].equals("") && typAtributu[2][y].equals("cislo") && vaha == 0) {
hodnota = Double.parseDouble(stav[x][y]);
sumaSmoch = sumaSmoch + (hodnota - vysledkyPopisStat[3][y])*(hodnota - vysledkyPopisStat[3][y]);
delitelSmoch++;
}
if (!stav[x][y].equals("") && typAtributu[2][y].equals("cislo") && vaha > 0) {
hodnota = Double.parseDouble(stav[x][y]);
sumaSmoch = sumaSmoch + (((hodnota - vysledkyPopisStat[3][y])*(hodnota - vysledkyPopisStat[3][y]))*Double.parseDouble(stav[x][vaha]));
delitelSmoch = delitelSmoch + Double.parseDouble(stav[x][vaha]);
}

}

vysledkyPopisStat[4][y] = (double)Math.round(Math.sqrt(sumaSmoch/(delitelSmoch-1)) * 100)/100;
sumaSmoch = 0;
delitelSmoch = 1;
}

double hodnotaMod = 0;
for (y = 1; y <= kolikSloupcu; y++) {

vysledkyPopisStat[5][y] = Double.MIN_VALUE;
  hodnotyModus[y] = "No mode";
for (x = 1; x <= kolikRadku; x++) {

if (!frekvence[x][y][2].equals("") && (vaha == 0)) {
  hodnotaMod = Double.parseDouble(frekvence[x][y][2]);
    if (vysledkyPopisStat[5][y] < hodnotaMod) {
  vysledkyPopisStat[5][y] = hodnotaMod;
    
 }

}

if (!frekvence[x][y][2].equals("") && (vaha != 0)) {
hodnotaMod = Double.parseDouble(frekvence[x][y][2]);

if (vysledkyPopisStat[5][y] < hodnotaMod) {
  vysledkyPopisStat[5][y] = hodnotaMod ;
  }

}

}
int multiModus = 0;
String modus = "";
for (x = 1; x <= kolikRadku; x++) {
if (!frekvence[x][y][2].equals("") && (Double.parseDouble(frekvence[x][y][2]) == vysledkyPopisStat[5][y])) {
multiModus++;
modus = "" + frekvence[x][y][1];
}
}
if (multiModus == 1) {
hodnotyModus[y] = modus;
}

}


} // metoda popis   

} // class
