/**
 * Tda slou k uloen vech potebnch datovch struktur
 *  
 */

import java.util.*;
import javax.swing.*;

public class DataKapsa
{

String[][] stavData;
int pocetRadkuSouboru;
int pocetSloupcuSouboru; 
String[] jmenaAtributuVaha;
String[] jmenaAtributuCil;
String[] jmenaAtributu;
String[][] typAtributu;
String[][][] frekvence;
String[][] vybraneObj;
double [][] popisStatistika;
String[] hodnotyModus;
double[] attrRelevance; 
double[][] conti;
int [] pocetHodnotAtributu;
String[][] dataTrenovaci;
String[][] dataTestovaci;
double[] chi;

int pocetSloupcuTypuNumeric;
int vyberObjRadku;
int vybranyCil;
int vybranaVaha;
double sumaVah;
int discreditujiSloupec;

TreeSet<Integer> missingRows;
TreeSet<Integer> missingColumns;

public static DataKapsa instanceDataKapsa = new DataKapsa();

/** 
 * S datovmi strukturami pracuj vechny ostatn tdy, je tedy poteba, aby existovala jedin instance,
 * obsahujc data natenho souboru.
 * Nepjemn dsledek - chceme-li pracovat s jinm souborem, je nutn aplikaci zavt a spustit znovu.
 */
public static DataKapsa getInstance () {
return instanceDataKapsa;
}

private DataKapsa() {
chi = new double[31];
chi[0] = 0;
chi[1] = 3.84;
chi[2] = 5.99;
chi[3] = 7.81;
chi[4] = 9.49; 
chi[5] = 11.1;
chi[6] = 12.6;
chi[7] = 14.1;
chi[8] = 15.5;
chi[9] = 16.9;
chi[10] = 18.3;
chi[11] = 19.7;
chi[12] = 21.0;
chi[13] = 22.4;
chi[14] = 23.7;
chi[15] = 25.0;
chi[16] = 26.3;
chi[17] = 27.6;
chi[18] = 28.9;
chi[19] = 30.1;
chi[20] = 31.4;
chi[21] = 32.7;
chi[22] = 33.9;
chi[23] = 35.2;
chi[24] = 36.4;
chi[25] = 37.7;
chi[26] = 38.9;
chi[27] = 40.1;
chi[28] = 41.3;
chi[29] = 42.6;
chi[30] = 43.8;
}


/**
 * Metoda zjist, zda jsou jednotliv atributy numerick nebo textov.
 * Prochz data, sna se je pevst na typ double. Pokud se to u libovolnho daje 
 * pslunho sloupce nepovede, ozna atribut jako text a pejde na dal atribut (sloupec).
 */
public void isAttributeNumeric() {
typAtributu = new String [3][pocetSloupcuSouboru + 1];
typAtributu[1][0] = "nic";
typAtributu[2][0] = "nic";
for (int y = 1; y<=pocetSloupcuSouboru; y++) {
typAtributu[1][y] = stavData[1][y];
}

int x = 2;
boolean numeric = true;
for (int y = 1; y <= pocetSloupcuSouboru; y++) {
while (numeric && x <= pocetRadkuSouboru) {
try {
double hodnota = Double.parseDouble(stavData[x][y]);
}
catch (NumberFormatException e) {
if (!stavData[x][y].equals("") && !stavData[x][y].equals("?")) {
if (stavData[x][y].equals("?")) {
stavData[x][y] = "DPT - MISSING VALUE";
}
typAtributu[2][y] = "text";
numeric = false;
}
} // catch
x++;
} // while
if (numeric) {
typAtributu[2][y] = "cislo";
}
numeric = true;
x = 2;
} // for

} // isAttributeNumeric


/**
 * Metoda vytv a napluje pomocn datov struktury o typu, nzvech a potech atribut.
 */
public void zjistiAtributy() {
jmenaAtributuCil = new String[pocetSloupcuSouboru + 1];
int pocitadloNumeric = 1;
for (int i = 1; i<= pocetSloupcuSouboru; i++) {
jmenaAtributuCil[i] = typAtributu[1][i];
if (typAtributu[2][i].equals("cislo")) {
pocitadloNumeric++;
}
}
jmenaAtributuCil[0] = "choose";
pocetSloupcuTypuNumeric = pocitadloNumeric;
jmenaAtributuVaha = new String[pocitadloNumeric];
jmenaAtributuVaha[0] = "No weight";
int ii = 1;
for (int i = 1; i<= pocetSloupcuSouboru; i++) {
if (typAtributu[2][i].equals("cislo")) {
jmenaAtributuVaha[ii] = typAtributu[1][i];
ii++;
}
}
jmenaAtributu = new String[pocetSloupcuSouboru];
for (int i = 1; i<= pocetSloupcuSouboru; i++) {
jmenaAtributu[i-1] = jmenaAtributuCil[i];
}
} // zjistiAtributy

} // class

