import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;


public class Grafika
{
/**
 * Hlavn okno aplikace
 */
Frame f;
JButton tlacNactiSoubor;
JButton tlacVycistiOknoVysledku;
JButton tlacUlozOknoVysledku;
JButton tlacUlozVytvorenySoubor;
JButton tlacVyberVahu;
JButton tlacVyberCil;
/**
 * Povrzen vbru vhy a cle
 */
JButton tlacVyberCilOK;
JButton tlacZobrazDataDescription;
JButton tlacZobrazNoiseEvaluation;
JButton tlacZobrazAttributeRelevance;
JButton tlacZobrazAttributeDependence;
JButton tlacAktivujDiscretization;
JButton tlacDiscretizationConn;
JButton tlacDeaktivujDiscretization;
JButton tlacActivujGrouping;
JButton tlacHandlingMissingValues;
JButton tlacUlozVybraneSloupce;
JButton tlacUlozVybraneRadky;
JButton tlacAktivujVyberRadku;
JButton tlacAktivujSplitting;
JButton tlacSplitting;
JButton tlacAktivujSampling;
JButton tlacSampling;

/**
 * Tlatko pro potvrzen parametr procedury Grouping
 */
JButton tlacConfirmG;
/**
 * Tlatko pro potvrzen parametr procedury Discretization
 */

JButton tlacConfirmD;
/**
 * Tlatko pro proveden procedury Grouping
 */

JButton tlacGroupingConn;
JButton tlacGroupingNewAttr;
JButton tlacDeaktivujGrouping;
/**
 * Tlatko pro proveden aktivace komponent po ukonen procedur Row Selection nebo Splitting
 */
JButton tlacDeaktivujRowSelSplit;

JLabel labelSoubor;
/**
 * Label nad komponentou Selector Panel
 */
JLabel labelPanelVyberuAtributu;
/**
 * Label pod komponentou Selector Panel
 */

JLabel labelPanelVyberu;
JLabel labelVyber1;
JLabel labelVyber2;
JLabel labelVyber3;
JLabel labelMenu;
/**
 * Label pro optick oddlen prav a lev sti okna aplikace
 */

JLabel labelVata;

JTextField tfVyber1;
JTextField tfVyber2;
JTextField tfVyber3;

/**
 * Panel pro komponentu Selector Panel
 */

JPanel panelVyberuAtributu;

static JTextArea oknoVysledku;

JScrollPane posuvnik;

SelectorPanel sp;

Object[] hodnotyPaneluVyberuAtributu;

JComboBox comboVaha;
JComboBox comboCil;
/**
 * Combo pro procedury Grouping a Discretization
 */

JComboBox comboGroupDiscr;

JCheckBox chbZaradVyrad1;

CheckboxGroup chbgOddelovac;
Checkbox chbStrednik;
Checkbox chbCarka;

ButtonGroup chbgMoznosti;

//JRadioButton chbMoznost1;

/**
 * Pepna Ignore rows procedury Handling missing values 
 */

JRadioButton chbMoznost2;
/**
 * Pepna Most frequent procedury Handling missing values 
 */

JRadioButton chbMoznost3;
/**
 * Pepna Proportional procedury Handling missing values 
 */

JRadioButton chbMoznost4;
/**
 * Pepna Any value procedury Handling missing values 
 */

JRadioButton chbMoznost5;
/**
 * Pepna class sensitive grouping
 */

JRadioButton chbMoznost6;
/**
 * Pepna user given grouping
 */

JRadioButton chbMoznost7;
/**
 * Pepna ekvifrekvenn discretizace
 */

JRadioButton chbMoznost8;
/**
 * Pepna ekvidistantn discretizace
 */

JRadioButton chbMoznost9;
/**
 * Pepna crisp class discretizace
 */


/**
 * Pepna fuzzy discretizace
 */



DataKapsa datoveStruktury;

public Grafika()
    {
    }

/**
 * Rozmstn komponent v okn aplikace
 */
    
public void makeLayout() {
f = new Frame("Data preprocessing system for datamining");
f.addWindowListener(new WindowAdapter () {
public void windowClosing (WindowEvent e) {
System.exit(0);
}
});

f.setLayout(new GridBagLayout());


tlacNactiSoubor = new JButton("Open file");
makeComponent(f, tlacNactiSoubor, 0, 0, 1, 1, 0.0, 0.0);
tlacNactiSoubor.addActionListener(new provedNacteniSouboru());
tlacVycistiOknoVysledku = new JButton("-    Clear screen    -");
makeComponent(f, tlacVycistiOknoVysledku, 5, 30, 1, 1, 0.0, 0.0);
tlacVycistiOknoVysledku.addActionListener(new provedSmazatVysledky());
tlacUlozOknoVysledku = new JButton("-    Save screen    -");
makeComponent(f, tlacUlozOknoVysledku, 6, 30, 1, 1, 0.0, 0.0);
tlacUlozOknoVysledku.addActionListener(new provedUlozVysledky());
tlacUlozVytvorenySoubor = new JButton("-    Save file    -");
makeComponent(f, tlacUlozVytvorenySoubor, 7, 30, 1, 1, 0.0, 0.0);
tlacUlozVytvorenySoubor.addActionListener(new provedUlozSoubor());
tlacVyberVahu = new JButton("Choose weight");
makeComponent(f, tlacVyberVahu, 0, 1, 1, 1, 0.0, 0.0);
tlacVyberVahu.addActionListener(new provedVaha());
tlacVyberCil = new JButton("Choose target");
makeComponent(f, tlacVyberCil, 0, 2, 1, 1, 0.0, 0.0);
tlacVyberCil.addActionListener(new provedCil());
tlacVyberCilOK = new JButton("Confirm weight and target choice");
makeComponent(f, tlacVyberCilOK, 2, 2, 1, 1, 0.0, 0.0);
tlacVyberCilOK.addActionListener(new provedCilOK());
tlacZobrazDataDescription = new JButton("Show data description");
makeComponent(f, tlacZobrazDataDescription, 0, 6, 1, 1, 0.0, 0.0);
tlacZobrazDataDescription.addActionListener(new provedZobrazDD());
tlacZobrazNoiseEvaluation = new JButton("Show noise evaluation");
makeComponent(f, tlacZobrazNoiseEvaluation, 0, 7, 1, 1, 0.0, 0.0);
tlacZobrazNoiseEvaluation.addActionListener(new provedZobrazNoiseEvaluation());
tlacZobrazAttributeRelevance = new JButton("Show attribute relevance");
makeComponent(f, tlacZobrazAttributeRelevance, 0, 8, 1, 1, 0.0, 0.0);
tlacZobrazAttributeRelevance.addActionListener(new provedAttributeRelevance());
tlacZobrazAttributeDependence = new JButton("Show attribute dependence");
makeComponent(f, tlacZobrazAttributeDependence, 0, 9, 1, 1, 0.0, 0.0);
tlacZobrazAttributeDependence.addActionListener(new provedAttributeDependence());
tlacActivujGrouping = new JButton("Activate grouping");
makeComponent(f, tlacActivujGrouping, 1, 7, 1, 1, 0.0, 0.0);
tlacActivujGrouping.addActionListener(new provedActivateGrouping());
tlacGroupingConn = new JButton("Connect - Grouping");
makeComponent(f, tlacGroupingConn, 2, 23, 1, 1, 0.0, 0.0);
tlacGroupingConn.addActionListener(new provedGroupingConn());
tlacGroupingNewAttr = new JButton("Group new attribute");
makeComponent(f, tlacGroupingNewAttr, 2, 24, 1, 1, 0.0, 0.0);
tlacGroupingNewAttr.addActionListener(new provedGroupingNewAttr());

tlacDeaktivujGrouping = new JButton("Deactivate grouping");
makeComponent(f, tlacDeaktivujGrouping, 2, 7, 1, 1, 0.0, 0.0);
tlacDeaktivujGrouping.addActionListener(new provedDeaktivujGrouping());
tlacAktivujDiscretization = new JButton("Activate discretization");
makeComponent(f, tlacAktivujDiscretization, 1, 8, 1, 1, 0.0, 0.0);
tlacAktivujDiscretization.addActionListener(new provedAktivujDiscretization());
tlacDiscretizationConn = new JButton("Connect - Discretization");
makeComponent(f, tlacDiscretizationConn, 2, 26, 1, 1, 0.0, 0.0);
tlacDiscretizationConn.addActionListener(new provedDiscretizationConn());
tlacDeaktivujDiscretization = new JButton("Deactivate discretization");
makeComponent(f, tlacDeaktivujDiscretization, 2, 8, 1, 1, 0.0, 0.0);
tlacDeaktivujDiscretization.addActionListener(new provedDeaktivujDiscretization());

tlacHandlingMissingValues = new JButton("Handling missing values");
makeComponent(f, tlacHandlingMissingValues, 0, 10, 1, 1, 0.0, 0.0);
tlacHandlingMissingValues.addActionListener(new provedHandlingMissingValues());
tlacConfirmG = new JButton("Confirm choice - Grouping");
makeComponent(f, tlacConfirmG, 2, 22, 1, 1, 0.0, 0.0);
tlacConfirmG.addActionListener(new provedGroupingOK());
tlacConfirmD = new JButton("Confirm choice - Discretization");
makeComponent(f, tlacConfirmD, 2, 25, 1, 1, 0.0, 0.0);
tlacConfirmD.addActionListener(new provedDiscretizationOK());
labelSoubor = new JLabel("File: ");
makeComponent(f, labelSoubor, 1, 0, 7, 1, 0.0, 0.0);
labelSoubor.setVisible(false);
labelVata = new JLabel(".");
makeComponent(f, labelVata, 4, 30, 1, 1, 0.0, 0.0);

labelMenu = new JLabel("Menu");
makeComponent(f, labelMenu, 0, 3, 1, 1, 0.0, 0.0);
labelPanelVyberuAtributu = new JLabel("Choose attributes pane");
makeComponent(f, labelPanelVyberuAtributu, 0, 11, 1, 1, 0.0, 0.0);
comboVaha = new JComboBox();
makeComponent(f, comboVaha, 1, 1, 1, 1, 0.0, 0.0);
comboCil = new JComboBox();
makeComponent(f, comboCil, 1, 2, 1, 1, 0.0, 0.0);
tlacUlozVybraneSloupce = new JButton("Save columns");
makeComponent(f, tlacUlozVybraneSloupce, 2, 6, 1, 1, 0.0, 0.0);
tlacUlozVybraneSloupce.addActionListener(new provedUlozVybraneSloupce());
tlacAktivujVyberRadku = new JButton("Activate rows selection");
makeComponent(f, tlacAktivujVyberRadku, 2, 9, 1, 1, 0.0, 0.0);
tlacAktivujVyberRadku.addActionListener(new provedAktivujVyberRadku());
tlacUlozVybraneRadky = new JButton("Save rows");
makeComponent(f, tlacUlozVybraneRadky, 2, 21, 1, 1, 0.0, 0.0);
tlacUlozVybraneRadky.addActionListener(new provedUlozVybraneRadky());
tfVyber1 = new JTextField(7);
makeComponent(f, tfVyber1, 1, 20, 1, 1, 0.0, 0.0);
tfVyber2 = new JTextField(7);
makeComponent(f, tfVyber2, 1, 21, 1, 1, 0.0, 0.0);
tfVyber3 = new JTextField(7);
makeComponent(f, tfVyber3, 1, 22, 1, 1, 0.0, 0.0);
labelPanelVyberu = new JLabel("Pane for user input");
makeComponent(f, labelPanelVyberu, 0, 19, 2, 1, 0.0, 0.0);
labelVyber1 = new JLabel("...");
makeComponent(f, labelVyber1, 0, 20, 1, 1, 0.0, 0.0);
labelVyber2 = new JLabel("...");
makeComponent(f, labelVyber2, 0, 21, 1, 1, 0.0, 0.0);
labelVyber3 = new JLabel("...");
makeComponent(f, labelVyber3, 0, 22, 1, 1, 0.0, 0.0);
chbZaradVyrad1 = new JCheckBox("");
makeComponent(f, chbZaradVyrad1, 0, 23, 1, 1, 0.0, 0.0);

tlacAktivujSampling = new JButton("Activate sampling");
makeComponent(f, tlacAktivujSampling, 1, 6, 1, 1, 0.0, 0.0);
tlacAktivujSampling.addActionListener(new provedAktivujSampling());
tlacSampling = new JButton("Sample");
makeComponent(f, tlacSampling, 2, 27, 1, 1, 0.0, 0.0);
tlacSampling.addActionListener(new provedSampling());



tlacAktivujSplitting = new JButton("Activate splitting");
makeComponent(f, tlacAktivujSplitting, 1, 9, 1, 1, 0.0, 0.0);
tlacAktivujSplitting.addActionListener(new provedAktivujSplitting());
tlacSplitting = new JButton("Splitt");
makeComponent(f, tlacSplitting, 2, 20, 1, 1, 0.0, 0.0);
tlacSplitting.addActionListener(new provedSplitting());
tlacDeaktivujRowSelSplit = new JButton("Deactivate Rows selection, Splitting, Sampling");
makeComponent(f, tlacDeaktivujRowSelSplit, 1, 10, 2, 1, 0.0, 0.0);
tlacDeaktivujRowSelSplit.addActionListener(new provedtlacDeaktivujRowSelSplit());

chbgOddelovac = new CheckboxGroup();
chbStrednik = new Checkbox("Semicolon delimited ", chbgOddelovac, true);
chbCarka = new Checkbox("Comma delimited ", chbgOddelovac, false);
makeComponent(f, chbStrednik, 1, 0, 1, 1, 0.0, 0.0);
makeComponent(f, chbCarka, 2, 0, 1, 1, 0.0, 0.0);

chbgMoznosti = new ButtonGroup();

//chbMoznost1 = new JRadioButton("Replace with DPT - Missing value ", false);
chbMoznost2 = new JRadioButton("Ignore rows", false);
chbMoznost3 = new JRadioButton("Most frequent", false);
chbMoznost4 = new JRadioButton("Proportional", false);
chbMoznost5 = new JRadioButton("Any value", false);
chbMoznost6 = new JRadioButton("Class sensitive", false);
chbMoznost7 = new JRadioButton("User given", false);
chbMoznost8 = new JRadioButton("Equidistant", false);
chbMoznost9 = new JRadioButton("Equifrequent", false);


//chbgMoznosti.add(chbMoznost1);
chbgMoznosti.add(chbMoznost2);
chbgMoznosti.add(chbMoznost3);
chbgMoznosti.add(chbMoznost4);
chbgMoznosti.add(chbMoznost5);
chbgMoznosti.add(chbMoznost6);
chbgMoznosti.add(chbMoznost7);
chbgMoznosti.add(chbMoznost8);
chbgMoznosti.add(chbMoznost9);


comboGroupDiscr = new JComboBox();
makeComponent(f, comboGroupDiscr, 1, 23, 1, 1, 0.0, 0.0);
makeComponent(f, chbMoznost2, 0, 24, 1, 1, 0.0, 0.0);
makeComponent(f, chbMoznost3, 1, 24, 1, 1, 0.0, 0.0);
makeComponent(f, chbMoznost4, 0, 25, 1, 1, 0.0, 0.0);
makeComponent(f, chbMoznost5, 1, 25, 1, 1, 0.0, 0.0);
makeComponent(f, chbMoznost6, 0, 26, 1, 1, 0.0, 0.0);
makeComponent(f, chbMoznost7, 1, 26, 1, 1, 0.0, 0.0);
makeComponent(f, chbMoznost8, 0, 27, 1, 1, 0.0, 0.0);
makeComponent(f, chbMoznost9, 1, 27, 1, 1, 0.0, 0.0);


chbMoznost2.addItemListener(new provedM2());
chbMoznost3.addItemListener(new provedM3());
chbMoznost4.addItemListener(new provedM4());
chbMoznost5.addItemListener(new provedM5());
chbMoznost6.addItemListener(new provedM6());
chbMoznost7.addItemListener(new provedM7());

//chbMoznost1.setEnabled(false);
comboGroupDiscr.setEnabled(false);
chbMoznost2.setEnabled(false);
chbMoznost3.setEnabled(false);
chbMoznost4.setEnabled(false);
chbMoznost5.setEnabled(false);
chbMoznost6.setEnabled(false);
chbMoznost7.setEnabled(false);
chbMoznost8.setEnabled(false);
chbMoznost9.setEnabled(false);



oknoVysledku = new JTextArea();
posuvnik = new JScrollPane(oknoVysledku);
makeComponent(f, posuvnik, 5, 5, 3, 24, 0.0, 0.0);
panelVyberuAtributu = new JPanel();
makeComponent(f, panelVyberuAtributu, 0, 12, 3, 6, 0.0, 0.0);
panelVyberuAtributu.setLayout(new BorderLayout());

setupUvod();
f.pack();
f.setVisible(true);
double vyskaOkna = f.getHeight();
double sirkaOkna = f.getWidth();
if (vyskaOkna < 700) {
vyskaOkna = 700;
}
if (sirkaOkna < 1000) {
sirkaOkna = 1000;
}
f.setSize((int)sirkaOkna,(int)vyskaOkna );
}


/**
 * Vytvoen jednotlivch komponent v v okn aplikace
 */

  void makeComponent(Container cont, Object arg, int x, int y, int w, int h, double weightx, double weighty) {
GridBagLayout gbl = (GridBagLayout)cont.getLayout();
GridBagConstraints c = new GridBagConstraints();
Component comp;

c.fill = GridBagConstraints.BOTH;
c.gridx = x;
c.gridy = y;
c.gridwidth = w;
c.gridheight = h;
c.weightx = weightx;
c.weighty = weighty;
if (arg instanceof String) {
comp = new Button((String)arg);
}
else {
comp = (Component)arg;
}
cont.add(comp);
gbl.setConstraints(comp, c);
} // makeComponent

/**
 * Prvotn nastaven aktivnch a neaktivnch komponent v okn aplikace
 */

void setupUvod() {
oknoVysledku.setText(oknoVysledku.getText() + "\n\n ********************************** ");
oknoVysledku.setText(oknoVysledku.getText() + "\n HELP - Getting started with DPT ");
oknoVysledku.setText("\n\n At first, please, press Open file button and choose the file   ");
oknoVysledku.setText(oknoVysledku.getText() + "\n you want to work with. Then choose weight and ");
oknoVysledku.setText(oknoVysledku.getText() + "\n target attribute. Press Confirm weight and target choice button. ");
oknoVysledku.setText(oknoVysledku.getText() + " ");

tlacUlozVybraneRadky.setEnabled(false);
tlacSplitting.setEnabled(false);
tlacSampling.setEnabled(false);
tlacUlozVytvorenySoubor.setEnabled(false);
tlacVyberVahu.setEnabled(false);
tlacVyberCil.setEnabled(false);
tlacVyberCilOK.setEnabled(false);
tlacZobrazDataDescription.setEnabled(false);
tlacZobrazNoiseEvaluation.setEnabled(false);
tlacZobrazAttributeRelevance.setEnabled(false);
tlacZobrazAttributeDependence.setEnabled(false);
tlacAktivujDiscretization.setEnabled(false);
tlacActivujGrouping.setEnabled(false);
tlacHandlingMissingValues.setEnabled(false);
tlacUlozVybraneSloupce.setEnabled(false);
tlacAktivujVyberRadku.setEnabled(false);
tlacAktivujSplitting.setEnabled(false);
tlacAktivujSampling.setEnabled(false);
tfVyber1.setEnabled(false);
tfVyber2.setEnabled(false);
tfVyber3.setEnabled(false);
comboVaha.setEnabled(false);
comboCil.setEnabled(false);
comboGroupDiscr.setEnabled(false);
chbZaradVyrad1.setEnabled(false);
tlacGroupingConn.setEnabled(false);
tlacGroupingNewAttr.setEnabled(false);
tlacDiscretizationConn.setEnabled(false);
tlacConfirmG.setEnabled(false);
tlacConfirmD.setEnabled(false);
tlacDeaktivujGrouping.setEnabled(false);
tlacDeaktivujDiscretization.setEnabled(false);
tlacDeaktivujRowSelSplit.setEnabled(false);
chbMoznost2.setEnabled(false);
chbMoznost3.setEnabled(false);
chbMoznost4.setEnabled(false);
chbMoznost5.setEnabled(false);
chbMoznost6.setEnabled(false);
chbMoznost7.setEnabled(false);
chbMoznost8.setEnabled(false);
chbMoznost9.setEnabled(false);



}

/**
 * Obecn nastaven aktivnch a neaktivnch komponent v okn aplikace pro zatek prce s vybranmi procedurami
 */

void setupF() {
tlacUlozVybraneRadky.setEnabled(false);
tlacSplitting.setEnabled(false);
tlacSampling.setEnabled(false);
tlacZobrazDataDescription.setEnabled(false);
tlacZobrazNoiseEvaluation.setEnabled(false);
tlacZobrazAttributeRelevance.setEnabled(false);
tlacZobrazAttributeDependence.setEnabled(false);
tlacAktivujDiscretization.setEnabled(false);
tlacActivujGrouping.setEnabled(false);
tlacHandlingMissingValues.setEnabled(false);
tlacUlozVybraneSloupce.setEnabled(false);
tlacAktivujVyberRadku.setEnabled(false);
tlacAktivujSplitting.setEnabled(false);
tlacAktivujSampling.setEnabled(false);
labelPanelVyberu.setText("Pane for user input");
labelVyber1.setText("...");
labelVyber2.setText("...");
labelVyber3.setText("...");
tfVyber1.setText("");
tfVyber2.setText("");
tfVyber3.setText("");
tfVyber1.setEnabled(false);
tfVyber2.setEnabled(false);
tfVyber3.setEnabled(false);
chbZaradVyrad1.setText("");
chbZaradVyrad1.setSelected(false);
chbZaradVyrad1.setEnabled(false);
comboGroupDiscr.setEnabled(false);
comboGroupDiscr.removeAllItems();
tlacGroupingConn.setEnabled(false);
tlacGroupingNewAttr.setEnabled(false);
tlacDiscretizationConn.setEnabled(false);
tlacConfirmG.setEnabled(false);
tlacConfirmD.setEnabled(false);
tlacDeaktivujGrouping.setEnabled(false);
tlacDeaktivujDiscretization.setEnabled(false);
tlacDeaktivujRowSelSplit.setEnabled(false);
chbMoznost2.setEnabled(false);
chbMoznost3.setEnabled(false);
chbMoznost4.setEnabled(false);
chbMoznost5.setEnabled(false);
chbMoznost6.setEnabled(false);
chbMoznost7.setEnabled(false);
chbMoznost8.setEnabled(false);
chbMoznost9.setEnabled(false);


chbMoznost2.setSelected(false);
chbMoznost3.setSelected(false);
chbMoznost4.setSelected(false);
chbMoznost5.setSelected(false);
chbMoznost6.setSelected(false);
chbMoznost7.setSelected(false);
chbMoznost8.setSelected(false);
chbMoznost9.setSelected(false);


f.setVisible(true);

}

/**
 * Obecn nastaven aktivnch a neaktivnch komponent v okn aplikace po skonen prce s vybranmi procedurami
 */

void setupT() {
tlacUlozVybraneRadky.setEnabled(false);
tlacSplitting.setEnabled(false);
tlacSampling.setEnabled(false);
tlacUlozVytvorenySoubor.setEnabled(true);
tlacZobrazDataDescription.setEnabled(true);
tlacZobrazNoiseEvaluation.setEnabled(true);
tlacZobrazAttributeRelevance.setEnabled(true);
tlacZobrazAttributeDependence.setEnabled(true);
tlacAktivujDiscretization.setEnabled(true);
tlacActivujGrouping.setEnabled(true);
tlacHandlingMissingValues.setEnabled(true);
tlacUlozVybraneSloupce.setEnabled(true);
tlacAktivujVyberRadku.setEnabled(true);
tlacAktivujSplitting.setEnabled(true);
tlacAktivujSampling.setEnabled(true);
labelPanelVyberu.setText("Pane for user input");
labelVyber1.setText("...");
labelVyber2.setText("...");
labelVyber3.setText("...");
tfVyber1.setText("");
tfVyber2.setText("");
tfVyber3.setText("");
tfVyber1.setEnabled(false);
tfVyber2.setEnabled(false);
tfVyber3.setEnabled(false);
chbZaradVyrad1.setText("");
chbZaradVyrad1.setSelected(false);
chbZaradVyrad1.setEnabled(false);
comboGroupDiscr.setEnabled(false);
comboGroupDiscr.removeAllItems();
tlacGroupingConn.setEnabled(false);
tlacGroupingNewAttr.setEnabled(false);
tlacDiscretizationConn.setEnabled(false);
tlacConfirmG.setEnabled(false);
tlacConfirmD.setEnabled(false);
tlacDeaktivujGrouping.setEnabled(false);
tlacDeaktivujDiscretization.setEnabled(false);
tlacDeaktivujRowSelSplit.setEnabled(false);
chbMoznost2.setEnabled(false);
chbMoznost3.setEnabled(false);
chbMoznost4.setEnabled(false);
chbMoznost5.setEnabled(false);
chbMoznost6.setEnabled(false);
chbMoznost7.setEnabled(false);
chbMoznost8.setEnabled(false);
chbMoznost9.setEnabled(false);


chbMoznost2.setSelected(false);
chbMoznost3.setSelected(false);
chbMoznost4.setSelected(false);
chbMoznost5.setSelected(false);
chbMoznost6.setSelected(false);
chbMoznost7.setSelected(false);
chbMoznost8.setSelected(false);
chbMoznost9.setSelected(false);


f.setVisible(true);
}

/**
 * Nate soubor do pamti
 */

class provedNacteniSouboru implements ActionListener {
public void actionPerformed (ActionEvent e) {
setupUvod();
NactiCSVSoubor csvSoubor = new NactiCSVSoubor();
datoveStruktury = datoveStruktury.getInstance();
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showOpenDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
oknoVysledku.setText(oknoVysledku.getText() + "\n\n Working with file "+ fc.getCurrentDirectory().toString() + "\\" + fc.getSelectedFile().getName());
oknoVysledku.setText(oknoVysledku.getText() + "\n" );
if (chbStrednik.getState()) {
csvSoubor.nacti(""+ fc.getCurrentDirectory().toString() +  "\\" + fc.getSelectedFile().getName(), ";");
} else {
csvSoubor.nacti(""+ fc.getCurrentDirectory().toString() +  "\\" + fc.getSelectedFile().getName(), ",");
}
//csvSoubor.isAttributeNumeric();
datoveStruktury.stavData = csvSoubor.getStav();
datoveStruktury.pocetRadkuSouboru = csvSoubor.getPocetRadku();
datoveStruktury.pocetSloupcuSouboru = csvSoubor.getPocetSloupcu();
datoveStruktury.missingRows = csvSoubor.missingRows;
datoveStruktury.missingColumns = csvSoubor.missingColumns;
datoveStruktury.isAttributeNumeric();
oknoVysledku.setText(oknoVysledku.getText() + "\n");
tlacVyberVahu.setEnabled(true);


chbStrednik.setVisible(false);
chbCarka.setVisible(false);
labelSoubor.setVisible(true);
tlacVyberVahu.setEnabled(true);
tlacNactiSoubor.setEnabled(false);
labelSoubor.setText("File: "+ fc.getCurrentDirectory().toString() +  "\\" + fc.getSelectedFile().getName());
f.setVisible(true);
}
}
};


/**
 * Nate nzvy atribut do comba, aby bylo mono vybrat vhu
 */

class provedVaha implements ActionListener {
public void actionPerformed (ActionEvent e) {
datoveStruktury.zjistiAtributy();
comboVaha.removeAllItems();
int pocetSloupcu = datoveStruktury.pocetSloupcuTypuNumeric;
for (int i = 0; i< pocetSloupcu; i++) {
comboVaha.addItem(datoveStruktury.jmenaAtributuVaha[i]);
}
comboVaha.setEnabled(true);
tlacVyberCil.setEnabled(true);

}
};

/**
 * Nate nzvy atribut do comba, aby bylo mono vybrat clov atribut
 */

class provedCil implements ActionListener {
public void actionPerformed (ActionEvent e) {
tlacVyberCilOK.setEnabled(true);
comboCil.removeAllItems();
int pocetSloupcu = datoveStruktury.pocetSloupcuSouboru;
String vybranaVaha = (String)comboVaha.getSelectedItem();
for (int i = 0; i<= pocetSloupcu; i++) {
if (!datoveStruktury.jmenaAtributuCil[i].equals(vybranaVaha)) {
comboCil.addItem(datoveStruktury.jmenaAtributuCil[i]);
}
else {
datoveStruktury.vybranaVaha = i;
}
}
comboVaha.setEnabled(false);
comboCil.setEnabled(true);
tlacVyberCilOK.setEnabled(true);
}
};

/**
 * Nate nzvy atribut do Selector panelu, provede zkladn statistick vpoty a ulo vsledky do Datakapsy. 
 * Aktivuje tlatka pro jednotliv procedury
 */

class provedCilOK implements ActionListener {
public void actionPerformed (ActionEvent e) {

if (comboCil.getSelectedItem().equals("choose")) {
JOptionPane.showMessageDialog(null, "Please, choose target attribute!", "No target attribut", JOptionPane.INFORMATION_MESSAGE);
}
else {

oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Weight is attribut: " + comboVaha.getSelectedItem() + "\n" + "Target is atribut: " + comboCil.getSelectedItem());


String cilS = comboCil.getSelectedItem().toString();
for (int y = 0; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if (datoveStruktury.jmenaAtributuCil[y].equals(cilS)) {
datoveStruktury.vybranyCil = y;
}
}
// naplneni panelu pro vyber atributu

hodnotyPaneluVyberuAtributu = datoveStruktury.jmenaAtributu;
sp = new SelectorPanel(hodnotyPaneluVyberuAtributu);
panelVyberuAtributu.setBorder(BorderFactory.createLineBorder(Color.black, 1));
panelVyberuAtributu.add(sp);

tlacVyberCil.setEnabled(false);
tlacVyberVahu.setEnabled(false);
comboCil.setEnabled(false);
tlacVyberCilOK.setEnabled(false);

f.setVisible(true);

// provedeni popisne statistiky
DataDescription dataDes = new DataDescription();
dataDes.popis(datoveStruktury.stavData, datoveStruktury.pocetRadkuSouboru, datoveStruktury.pocetSloupcuSouboru, datoveStruktury.vybranaVaha, datoveStruktury.typAtributu );

oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Data Description done...  ");
datoveStruktury.frekvence = dataDes.getFrekvence();
datoveStruktury.popisStatistika = dataDes.getVysledkyPopisStat();
datoveStruktury.pocetHodnotAtributu = dataDes.getPocetHodnotAtributu();
datoveStruktury.hodnotyModus = dataDes.getHodnotyModus();
datoveStruktury.stavData = dataDes.getStavData();
datoveStruktury.sumaVah = dataDes.getSumaVah();
setupT();
}
}
};

/**
 * Zobraz zkladn statistick popis dat pro vybran atributy. 
 */

class provedZobrazDD implements ActionListener {
public void actionPerformed (ActionEvent e) {
int pocetVybranychAtributu = sp.selectedList.getModel().getSize();
Object[] vybraneAtributy = sp.selectedModel.getValues();
int y = 0;
for (int z = 0; z < pocetVybranychAtributu; z++) {
 for (int i = 1; i <= datoveStruktury.pocetSloupcuSouboru; i++) {
if ( ((String)vybraneAtributy[z]).equals(datoveStruktury.stavData[1][i])) {
 y = i;
 break;
 }
 }

oknoVysledku.setText(oknoVysledku.getText() + "\n\n" + "Attribut: " + datoveStruktury.jmenaAtributuCil[y] + " Pocet hodnot: " + datoveStruktury.pocetHodnotAtributu[y]);
for (int x = 1; x <= 6; x++) {
if (x == 1) {oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Minimum: " + datoveStruktury.popisStatistika[1][y]);}
if (x == 2) {oknoVysledku.setText(oknoVysledku.getText() + "  " + "Maximum: " + datoveStruktury.popisStatistika[2][y]);}
if (x == 3) {oknoVysledku.setText(oknoVysledku.getText() + "  " + "Mean: " + datoveStruktury.popisStatistika[3][y]);}
if (x == 4) {oknoVysledku.setText(oknoVysledku.getText() + "  " + "Smoch: " + datoveStruktury.popisStatistika[4][y]);}
if (x == 5) {oknoVysledku.setText(oknoVysledku.getText() + "  " + "Mode: " + datoveStruktury.hodnotyModus[y]);}
}
for (int w = 1; w <= datoveStruktury.pocetRadkuSouboru; w++ ) {
if (!datoveStruktury.frekvence[w][y][1].equals("")) {
oknoVysledku.setText(oknoVysledku.getText() + "\n" + " Value " + datoveStruktury.frekvence[w][y][1] + "\t Frequency " + datoveStruktury.frekvence[w][y][2] + "\t Rel. frequency " + datoveStruktury.frekvence[w][y][3]);
}
}
}
}
};

/**
 * Provede vpoet a zobraz vsledky procedury Attribute Relevance pro vybran atributy.
 */

class provedAttributeRelevance implements ActionListener {
public void actionPerformed (ActionEvent e) {
AttributeRelevance ar = new AttributeRelevance();
int pocetVybranychAtributu = sp.selectedList.getModel().getSize();
if (pocetVybranychAtributu < 1) {
JOptionPane.showMessageDialog(null, "You did not choose any attribute ... ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
else {
Object[] vybraneAtributy = sp.selectedModel.getValues();
int y = 0;
for (int z = 0; z < pocetVybranychAtributu; z++) {
 for (int i = 1; i <= datoveStruktury.pocetSloupcuSouboru; i++) {
if ( ((String)vybraneAtributy[z]).equals(datoveStruktury.stavData[1][i])) {
 y = i;
 break;
 }
 }


ar.spocitejAtribut(datoveStruktury.stavData, datoveStruktury.frekvence, datoveStruktury.pocetRadkuSouboru, y, datoveStruktury.typAtributu[1][y], datoveStruktury.pocetHodnotAtributu[y], datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil], datoveStruktury.vybranyCil, datoveStruktury.vybranaVaha);
datoveStruktury.attrRelevance = ar.relevance;
}
}
}
};

/**
 * Vyist okno vsledk
 */

class provedSmazatVysledky implements ActionListener {
public void actionPerformed (ActionEvent e) {
oknoVysledku.setText("");
}
};

/**
 * Ulo obsah okna vsledk do textovho souboru
 */


class provedUlozVysledky implements ActionListener {
public void actionPerformed (ActionEvent e) {
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".txt")||ff.isDirectory();
}
public String getDescription() {
return "*.txt";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".txt");
PrintWriter vystup = new PrintWriter(fw);
oknoVysledku.write(vystup);
}
catch (IOException ee) {
oknoVysledku.setText(oknoVysledku.getText() + "\n\n Output problem");
}

}

}
};

/**
 * Ulo obsah pole stavData instance datoveStruktury tdy Datakapsa do csv souboru
 */


class provedUlozSoubor implements ActionListener {
public void actionPerformed (ActionEvent e) {
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
vystup.print("" + datoveStruktury.stavData[x][y] + ";");
}
vystup.println();
}
vystup.close();
}
catch (IOException ee) {
oknoVysledku.setText(oknoVysledku.getText() + "\n Output problem");
}

}

}
};

/**
 * Ulo sloupce vybran pomoc Selector panelu do csv souboru
 */

class provedUlozVybraneSloupce implements ActionListener {
public void actionPerformed (ActionEvent e) {
ASMI asmi = new ASMI();
asmi.MI();
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
int pocetVybranychAtributu = sp.selectedList.getModel().getSize();
Object[] vybraneAtributy = sp.selectedModel.getValues();

for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {

for (int z = 0; z < pocetVybranychAtributu; z++) {
if ( ((String)vybraneAtributy[z]).equals(datoveStruktury.stavData[1][y])) {
vystup.print("" + datoveStruktury.stavData[x][y] + ";");
}
}
}
vystup.println();

}
vystup.close();
}
catch (IOException ee) {
oknoVysledku.setText(oknoVysledku.getText() + "\n Output problem");
}

}

}
};

/**
 * Ulo specifikovan dky do csv souboru
 */

class provedUlozVybraneRadky implements ActionListener {
public void actionPerformed (ActionEvent e) {

int prvniObj = 0;
int posledniObj = 0;
try {
prvniObj = Integer.parseInt(tfVyber1.getText());
posledniObj = Integer.parseInt(tfVyber2.getText());
if ((prvniObj < 1) || (posledniObj < 1) ) {
tfVyber1.setText("");
tfVyber2.setText("");
JOptionPane.showMessageDialog(null, "Wrong value in From or To field! Please, enter integer value > 0!", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
}
catch (NumberFormatException ee) {
JOptionPane.showMessageDialog(null, "Wrong value in From or To field! Please, enter integer value!", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
if (!chbZaradVyrad1.isSelected()) {
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if ((x >= prvniObj && x <= posledniObj) || x==1) {
vystup.print("" + datoveStruktury.stavData[x][y] + ";");
}
}
vystup.println();
}
vystup.close();
}
catch (IOException ee) {
oknoVysledku.setText(oknoVysledku.getText() + "\n Output problem");
}
}
}
else {
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
boolean odradkuj = false;
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if (x < prvniObj || x > posledniObj) {
vystup.print("" + datoveStruktury.stavData[x][y] + ";");
odradkuj = true;
}
}
if (odradkuj) {
vystup.println();
odradkuj = false;
}
}
vystup.close();
}
catch (IOException ee) {
oknoVysledku.setText(oknoVysledku.getText() + "\n Output problem");
}
}
}



}
};

/**
 * Aktivuje pole pro specifikaci dk, kter maj bt vybrny z natenho souboru
 */

class provedAktivujVyberRadku implements ActionListener {
public void actionPerformed (ActionEvent e) {
oknoVysledku.setText(oknoVysledku.getText() + "\n\n ******************************** ");
oknoVysledku.setText(oknoVysledku.getText() + "\n HELP for Row selection function: ");
oknoVysledku.setText(oknoVysledku.getText() + "\n\n Now you should enter number of the first and last row, you want to ");
oknoVysledku.setText(oknoVysledku.getText() + "\n include or exclude. Tick exclude choice to exclude rows, keep unchecked");
oknoVysledku.setText(oknoVysledku.getText() + "\n to include rows you specified. Then click on Save rows button. ");
oknoVysledku.setText(oknoVysledku.getText() + "\n The save file dialog will appear.  ");
oknoVysledku.setText(oknoVysledku.getText() + "\n When finished, click on Deactivate Row Selection, Splitting, Sampling. \n");
oknoVysledku.setText(oknoVysledku.getText() + " ");

setupF();
labelPanelVyberu.setText("Choose rows");
labelVyber1.setText("From");
labelVyber1.setEnabled(true);
labelVyber2.setText("To");
labelVyber2.setEnabled(true);
tfVyber1.setEnabled(true);
tfVyber2.setEnabled(true);
tlacUlozVybraneRadky.setEnabled(true);
chbZaradVyrad1.setText("Exclude rows");
chbZaradVyrad1.setEnabled(true);
tlacDeaktivujRowSelSplit.setEnabled(true);

f.setVisible(true);
}
};

/**
 * Provede rozdlen natenho souboru na trnovac a testovac data
 */


class provedSplitting implements ActionListener {
public void actionPerformed (ActionEvent e) {

Splitting splitt = new Splitting();
splitt.split(tfVyber1.getText(), tfVyber2.getText(), tfVyber3.getText(), chbZaradVyrad1.isSelected() );

}
};

/**
 * Aktivuje pole pro specifikaci rozdlen natenho souboru na trnovac a testovac data
 */

class provedAktivujSplitting implements ActionListener {
public void actionPerformed (ActionEvent e) {
oknoVysledku.setText(oknoVysledku.getText() + "\n\n ****************************************************** ");
oknoVysledku.setText(oknoVysledku.getText() + "\n HELP for Splitting function: ");
oknoVysledku.setText(oknoVysledku.getText() + "\n\n  Specify either absolute number of rows or relative ");
oknoVysledku.setText(oknoVysledku.getText() + "\n percentage of rows you want to include into training set. ");
oknoVysledku.setText(oknoVysledku.getText() + "\n You can also specify how many times you want to  ");
oknoVysledku.setText(oknoVysledku.getText() + "\n repeat this procedure. ");
oknoVysledku.setText(oknoVysledku.getText() + "\n Tick Stratified division if you want to keep the ratio");
oknoVysledku.setText(oknoVysledku.getText() + "\n between classes. Then click on Split button.");
oknoVysledku.setText(oknoVysledku.getText() + "\n Save dialog will appear twice. First file you are saving, ");
oknoVysledku.setText(oknoVysledku.getText() + "\n is training set, second is testing set. ");
oknoVysledku.setText(oknoVysledku.getText() + "\n When finished, click on Deactivate Rows Selection, Splitting,");
oknoVysledku.setText(oknoVysledku.getText() + "\n Sampling button.");

setupF();
labelPanelVyberu.setText("Data splitting");
labelVyber1.setText("Relative");
labelVyber1.setEnabled(true);
labelVyber2.setText("Absolute");
labelVyber2.setEnabled(true);
labelVyber3.setText("Repeat");
labelVyber3.setEnabled(true);
tfVyber1.setEnabled(true);
tfVyber2.setEnabled(true);
tfVyber3.setText("1");
tfVyber3.setEnabled(true);
tlacSplitting.setEnabled(true);
chbZaradVyrad1.setText("Stratified division");
chbZaradVyrad1.setEnabled(true);
tlacDeaktivujRowSelSplit.setEnabled(true);
f.setVisible(true);
}
};

class provedSampling implements ActionListener {
public void actionPerformed (ActionEvent e) {

String trida = (String)comboGroupDiscr.getSelectedItem();
Sampling sampl = new Sampling();
sampl.sample(tfVyber1.getText(), tfVyber2.getText(), tfVyber3.getText(), chbZaradVyrad1.isSelected(), trida );

}
};

/**
 * Aktivuje pole pro specifikaci rozdlen natenho souboru na trnovac a testovac data
 */

class provedAktivujSampling implements ActionListener {
public void actionPerformed (ActionEvent e) {
oknoVysledku.setText(oknoVysledku.getText() + "\n\n ************************************************* ");
oknoVysledku.setText(oknoVysledku.getText() + "\n HELP for Sampling function.");
oknoVysledku.setText(oknoVysledku.getText() + "\n\n  Specify either absolute number of rows or relative ");
oknoVysledku.setText(oknoVysledku.getText() + "\n percentage of rows you want to include into training set. ");
oknoVysledku.setText(oknoVysledku.getText() + "\n Tick Stratified division if you want to keep the ratio");
oknoVysledku.setText(oknoVysledku.getText() + "\n between classes. Choose the class from combobox if you");
oknoVysledku.setText(oknoVysledku.getText() + "\n want to include all object of some class. ");
oknoVysledku.setText(oknoVysledku.getText() + "\n Then click on Sample button.");
oknoVysledku.setText(oknoVysledku.getText() + "\n Save dialog will appear. ");
oknoVysledku.setText(oknoVysledku.getText() + "\n When finished, click on Deactivate Rows Selection, Splitting,");
oknoVysledku.setText(oknoVysledku.getText() + "\n Sampling button.");


setupF();
labelPanelVyberu.setText("Data sampling");
labelVyber1.setText("Relative");
labelVyber1.setEnabled(true);
labelVyber2.setText("Absolute");
labelVyber2.setEnabled(true);
labelVyber3.setText("Repeat");
labelVyber3.setEnabled(true);
tfVyber1.setEnabled(true);
tfVyber2.setEnabled(true);
tfVyber3.setText("...");
tfVyber3.setEnabled(false);
tlacSampling.setEnabled(true);
chbZaradVyrad1.setText("Stratified division");
chbZaradVyrad1.setEnabled(true);
tlacDeaktivujRowSelSplit.setEnabled(true);

comboGroupDiscr.removeAllItems();

comboGroupDiscr.addItem("whole class");
for (int i = 1; i<= datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil]; i++) {
if (!datoveStruktury.frekvence[i][datoveStruktury.vybranyCil][1].equals("")) {
comboGroupDiscr.addItem(datoveStruktury.frekvence[i][datoveStruktury.vybranyCil][1]);

}
}
comboGroupDiscr.setEnabled(true);

f.setVisible(true);
}
};


/**
 * Provede vpoet a zobraz vsledky procedury Attribute Dependence
 */

class provedAttributeDependence implements ActionListener {
public void actionPerformed (ActionEvent e) {

AttributeDependence ad = new AttributeDependence();
ad.init();
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + " \n " + "Attribute dependence: ");
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + " \n " + " All attributes: \n");

int pocetVybranychAtributu = sp.selectedList.getModel().getSize();
Object[] vybraneAtributy = sp.selectedModel.getValues();
int y = 0;
int yy = 0;
for (int z = 0; z < pocetVybranychAtributu; z++) {
for (int zz = 0; zz < pocetVybranychAtributu; zz++) {
if ( z < zz) {
 for (int s = 1; s <= datoveStruktury.pocetSloupcuSouboru; s++) {
if ( ((String)vybraneAtributy[z]).equals(datoveStruktury.stavData[1][s])) {
 y = s;
 break;
 }
 }

 for (int t = 1; t <= datoveStruktury.pocetSloupcuSouboru; t++) {
if ( ((String)vybraneAtributy[zz]).equals(datoveStruktury.stavData[1][t])) {
 yy = t;
 break;
 }
 }

if (y != datoveStruktury.vybranaVaha && yy!= datoveStruktury.vybranaVaha) {
String text = "Attribut: " + (String)vybraneAtributy[z] + " and attribute " + (String)vybraneAtributy[zz] + " : "; 
ad.dependence(y, yy, text);
}



} // if z < zz
} // for zz
} // for z

oknoVysledku.setText(Grafika.oknoVysledku.getText() + " \n\n " + " Top attributes: \n"); 
TreeMap<String, Double> mapAD = new TreeMap<String, Double>();
mapAD = ad.getMaxMap();
String maxAtribut = "";
double maxVysledek1 = 0;
double maxVysledek2 = ad.getMaxVysledek();

Set<Map.Entry<String,Double>> mnozinaDvojic = mapAD.entrySet(); 
for(Map.Entry <String, Double> dvojice : mnozinaDvojic) { 
maxAtribut = "" + dvojice.getKey();
maxVysledek1 = dvojice.getValue();
if (maxVysledek1 == maxVysledek2) {
oknoVysledku.setText(Grafika.oknoVysledku.getText() + " \n " + maxAtribut + maxVysledek1); 
}
}


}
};

/**
 * Provede vpoet a zobraz vsledky procedury Noise Evaluation
 */


class provedZobrazNoiseEvaluation implements ActionListener {
public void actionPerformed (ActionEvent e) {

NoiseEvaluation ne = new NoiseEvaluation();
ne.noise();

}
};

/**
 * Aktivuje prvn st pol pro specifikaci parametr Discretizace
 */

class provedAktivujDiscretization implements ActionListener {
public void actionPerformed (ActionEvent e) {

oknoVysledku.setText(oknoVysledku.getText() + "\n\n ************************************************ ");
oknoVysledku.setText(oknoVysledku.getText() + "\n HELP for Discretization function:");
oknoVysledku.setText(oknoVysledku.getText() + "\n\n First choose type of discretization and then ");
oknoVysledku.setText(oknoVysledku.getText() + "\n choose the attribute from combobox.");
oknoVysledku.setText(oknoVysledku.getText() + "\n Click on Confirm choice - Discretization button.  ");
oknoVysledku.setText(oknoVysledku.getText() + "\n Minimum and maximum values will appear in text fields.");
oknoVysledku.setText(oknoVysledku.getText() + "\n You can specify lower and upper border for interval.");
oknoVysledku.setText(oknoVysledku.getText() + "\n Specify the name for the interval too.");
oknoVysledku.setText(oknoVysledku.getText() + "\n Then click on Connect - Discretization button. ");
oknoVysledku.setText(oknoVysledku.getText() + "\n When finished, click on Deactivate Discreditation button.");



setupF();
labelPanelVyberu.setText("Choose type of Discreditation");
chbMoznost7.setEnabled(true);
chbMoznost8.setEnabled(true);
chbMoznost9.setEnabled(true);


chbMoznost7.setSelected(true);
tlacConfirmD.setEnabled(true);

comboGroupDiscr.removeAllItems();
int pocetSloupcu = datoveStruktury.pocetSloupcuSouboru;
String vybranaVaha = (String)comboVaha.getSelectedItem();
comboGroupDiscr.addItem("choose");
for (int i = 1; i<= pocetSloupcu; i++) {
if (!datoveStruktury.jmenaAtributuCil[i].equals(vybranaVaha) && (datoveStruktury.typAtributu[2][i].equals("cislo"))) {
comboGroupDiscr.addItem(datoveStruktury.jmenaAtributuCil[i]);

}
}
comboGroupDiscr.setEnabled(true);
tlacDiscretizationConn.setEnabled(false);
tlacDeaktivujDiscretization.setEnabled(true);
}
};

/**
 * Aktivuje druhou st pol pro specifikaci parametr Discretizace
 */

class provedDiscretizationOK implements ActionListener {
public void actionPerformed (ActionEvent e) {
tlacDiscretizationConn.setEnabled(true);
chbMoznost7.setEnabled(false);
chbMoznost8.setEnabled(false);
chbMoznost9.setEnabled(false);




if (!comboGroupDiscr.getSelectedItem().equals("choose")) {

int sloupec=0;

for (int i = 1; i <= datoveStruktury.pocetSloupcuTypuNumeric; i++) {
if (comboGroupDiscr.getSelectedItem().equals(datoveStruktury.jmenaAtributuCil[i])) {
sloupec = i;
break;
}
}

datoveStruktury.discreditujiSloupec = sloupec;
labelVyber1.setEnabled(true);
labelVyber2.setEnabled(true);
labelVyber3.setEnabled(true);
tfVyber1.setEnabled(true);
tfVyber2.setEnabled(true);
tfVyber3.setEnabled(true);

if (chbMoznost7.isSelected()  ) {

labelVyber1.setText("From (Min)"); 
labelVyber2.setText("To (Max)"); 
labelVyber3.setText("Interval name "); 
tfVyber1.setText("" + datoveStruktury.popisStatistika[1][sloupec]);
tfVyber2.setText("" + datoveStruktury.popisStatistika[2][sloupec]);

}
else if (chbMoznost8.isSelected()) {

labelVyber1.setText("From (Min)"); 
labelVyber2.setText("From (Max)"); 
labelVyber3.setText("Distance "); 
tfVyber1.setText("" + datoveStruktury.popisStatistika[1][sloupec]);
tfVyber2.setText("" + datoveStruktury.popisStatistika[2][sloupec]);


}
else if (chbMoznost9.isSelected()) {

labelVyber1.setText("From (Min)"); 
labelVyber2.setText("From (Max)"); 
labelVyber3.setText("How many intervals "); 
tfVyber1.setText("" + datoveStruktury.popisStatistika[1][sloupec]);
tfVyber2.setText("" + datoveStruktury.popisStatistika[2][sloupec]);


}

else {
JOptionPane.showMessageDialog(null, "You did not choose type of discretization... Use available radio buttons at bottom left. ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
}
else {
JOptionPane.showMessageDialog(null, "You did not choose attribute... Use available combobox in middle left. ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}

tlacConfirmD.setEnabled(false);
}
};

/**
 * Discretizace - vlastn spojen definovanch hodnot
 */


class provedDiscretizationConn implements ActionListener {
public void actionPerformed (ActionEvent e) {
int y = datoveStruktury.discreditujiSloupec;
if (chbMoznost7.isSelected()) {
if (!tfVyber3.getText().equals("")) {
double mala = 0;
double velka = 0;
boolean chyba = false;
try {
mala = Double.parseDouble(tfVyber1.getText());
velka = Double.parseDouble(tfVyber2.getText());
}
catch (NumberFormatException eee) {
JOptionPane.showMessageDialog(null, "Wrong minimum or maximum of interval!!! ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
chyba = true;
}

if (!chyba) { 
for (int x = 2; x <= datoveStruktury.pocetRadkuSouboru; x++) {
try {
double hodnota = Double.parseDouble(datoveStruktury.stavData[x][y]);
if ((hodnota >= mala ) && (hodnota <= velka)) {
datoveStruktury.stavData[x][y] = tfVyber3.getText();
}

}
catch (NumberFormatException ee) {
}
}

oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Values from " + tfVyber1.getText() + " to " + tfVyber2.getText() + " replaced by " + tfVyber3.getText() + "\n");
}
} 
else {
JOptionPane.showMessageDialog(null, "You did not specify Interval name... ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}


}
else if (chbMoznost8.isSelected()) {
try {
double distance = Double.parseDouble(tfVyber3.getText());
if ((tfVyber2.getText().length() > 0) && (tfVyber1.getText().length() == 0)) {

for (int x = 2; x <= datoveStruktury.pocetRadkuSouboru; x++) {
double highdistance = datoveStruktury.popisStatistika[2][datoveStruktury.discreditujiSloupec];
double lowdistance = highdistance - distance;
int i = 1;
boolean distanceChange = true;
while (distanceChange) {
double hodnota = Double.parseDouble(datoveStruktury.stavData[x][y]);
if (hodnota >= lowdistance && hodnota <= highdistance ){
datoveStruktury.stavData[x][y] = "value " + i;
distanceChange = false;
}
i++;
lowdistance = lowdistance - distance;
highdistance = highdistance - distance;
}
}
}
else{

for (int x = 2; x <= datoveStruktury.pocetRadkuSouboru; x++) {
double lowdistance = datoveStruktury.popisStatistika[1][datoveStruktury.discreditujiSloupec];
double highdistance = lowdistance + distance;
int i = 1;
boolean distanceChange = true;
while (distanceChange) {
double hodnota = Double.parseDouble(datoveStruktury.stavData[x][y]);
if (hodnota >= lowdistance && hodnota <= highdistance ){
datoveStruktury.stavData[x][y] = "value " + i;
distanceChange = false;
}
i++;
lowdistance = lowdistance + distance;
highdistance = highdistance + distance;
}
}

}
oknoVysledku.setText(oknoVysledku.getText() + "\n\n Discretization done...");
} 
catch (NumberFormatException eeee) {
JOptionPane.showMessageDialog(null, "You did not specify distance correctly ... ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}



}
else if (chbMoznost9.isSelected()) {

try {
double kolikIntervalu = Double.parseDouble(tfVyber3.getText());
double idealPocet = (datoveStruktury.pocetRadkuSouboru - 1)/kolikIntervalu;
int value = 1;
double dolni = 0;
double horni = 0;
double spodni = 0;
double vrchni = 0;
double rozdil = 0;
double cutPoint = idealPocet;
// y cili diskredit.sloupec je definovano na zacatku tridy

for (int x = 1; x <= datoveStruktury.pocetHodnotAtributu[y]; x++) {
horni = horni + Double.parseDouble(datoveStruktury.frekvence[x][y][2]);
if (horni <= cutPoint) {
datoveStruktury.frekvence[x][y][4] = "value " + value;

}
else {
spodni = cutPoint - dolni;
vrchni = horni - cutPoint;
cutPoint = cutPoint + idealPocet;
if ((spodni + rozdil) >= vrchni) {
datoveStruktury.frekvence[x][y][4] = "value " + value;
value++;
rozdil = cutPoint - horni;
}
else {
value++;
datoveStruktury.frekvence[x][y][4] = "value " + value;
rozdil = spodni;
}
}
dolni = horni;
}
oknoVysledku.setText(oknoVysledku.getText() + "\n\n Discretization done...");
} 
catch (NumberFormatException eeee) {
JOptionPane.showMessageDialog(null, "You did not specify number of intervals correctly ... ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
for (int x = 2; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int w = 1; w<= datoveStruktury.pocetHodnotAtributu[y]; w++) {
if (datoveStruktury.stavData[x][y].equals(datoveStruktury.frekvence[w][y][1])) {
datoveStruktury.stavData[x][y] = datoveStruktury.frekvence[w][y][4];
}

}
}
}
else {
JOptionPane.showMessageDialog(null, "Unexpected problem ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}

}
};

/**
 * Deaktivace pol pro vbr parametr discretizace a pepotn zkladn statistiky o souboru
 */


class provedDeaktivujDiscretization implements ActionListener {
public void actionPerformed (ActionEvent e) {
setupF();
setupT();

datoveStruktury.isAttributeNumeric();
DataDescription dataDes = new DataDescription();
dataDes.popis(datoveStruktury.stavData, datoveStruktury.pocetRadkuSouboru, datoveStruktury.pocetSloupcuSouboru, datoveStruktury.vybranaVaha, datoveStruktury.typAtributu );
datoveStruktury.frekvence = dataDes.getFrekvence();
datoveStruktury.popisStatistika = dataDes.getVysledkyPopisStat();
datoveStruktury.pocetHodnotAtributu = dataDes.getPocetHodnotAtributu();
datoveStruktury.hodnotyModus = dataDes.getHodnotyModus();
datoveStruktury.stavData = dataDes.getStavData();
datoveStruktury.sumaVah = dataDes.getSumaVah();

}
};

/**
 * Aktivace pepna pro specifikaci oeten chybjcch hodnot
 */


class provedHandlingMissingValues implements ActionListener {
public void actionPerformed (ActionEvent e) {
oknoVysledku.setText(oknoVysledku.getText() + "\n\n ********************************************** ");
oknoVysledku.setText(oknoVysledku.getText() + "\n HELP for Handling Missing Values function:");
oknoVysledku.setText(oknoVysledku.getText() + "\n\n Choose the type of handling and it will be ");
oknoVysledku.setText(oknoVysledku.getText() + "\n done immediately.");


setupF();
labelPanelVyberu.setText("Choose type of Handling Missing Values");
chbMoznost2.setEnabled(true);
chbMoznost3.setEnabled(true);
chbMoznost4.setEnabled(true);
chbMoznost5.setEnabled(true);

}
};

/**
 * Aktivace prvn sti pol pro specifikaci parametr procedury Grouping
 */

class provedActivateGrouping implements ActionListener {
public void actionPerformed (ActionEvent e) {
oknoVysledku.setText(oknoVysledku.getText() + "\n\n *********************************************** ");
oknoVysledku.setText(oknoVysledku.getText() + "\n HELP for Grouping function: ");
oknoVysledku.setText(oknoVysledku.getText() + "\n\n First choose type of grouping. ");
oknoVysledku.setText(oknoVysledku.getText() + "\n\n HELP for user given groupig:");
oknoVysledku.setText(oknoVysledku.getText() + "\n\n Choose attribute from combobox. Then click on ");
oknoVysledku.setText(oknoVysledku.getText() + "\n Confirm choice - Grouping button.");
oknoVysledku.setText(oknoVysledku.getText() + "\n Values of choosen attribute will appears in the ");
oknoVysledku.setText(oknoVysledku.getText() + "\n Choose attributes / values for Grouping pane.");
oknoVysledku.setText(oknoVysledku.getText() + "\n Choose those, you want to connect and move them");
oknoVysledku.setText(oknoVysledku.getText() + "\n to right side. Specify the name for connected");
oknoVysledku.setText(oknoVysledku.getText() + "\n values. Then click Connect - Grouping.");
oknoVysledku.setText(oknoVysledku.getText() + "\n When finished with attribute, you can choose new");
oknoVysledku.setText(oknoVysledku.getText() + "\n attribute. Click on Group new attribute button.");
oknoVysledku.setText(oknoVysledku.getText() + "\n When finished, click on Deactivate Grouping button.");
oknoVysledku.setText(oknoVysledku.getText() + "\n\n HELP for class sensitive grouping:");
oknoVysledku.setText(oknoVysledku.getText() + "\nn Choose attributes in the ");
oknoVysledku.setText(oknoVysledku.getText() + "\n Choose attributes / values for Grouping pane.");
oknoVysledku.setText(oknoVysledku.getText() + "\n Click on Connect - Grouping button. ");
oknoVysledku.setText(oknoVysledku.getText() + "\n When finished, click on Deactivate Grouping button.");

setupF();
labelPanelVyberu.setText("Choose type of Grouping");
labelPanelVyberuAtributu.setText("Choose attributes / values for Grouping pane");
chbMoznost6.setEnabled(true);
chbMoznost7.setEnabled(true);
tlacConfirmG.setEnabled(true);
tlacDeaktivujGrouping.setEnabled(true);
}
};

/**
 * Aktivace druh sti pol pro specifikaci parametr procedury Grouping
 */

class provedGroupingOK implements ActionListener {
public void actionPerformed (ActionEvent e) {
if (chbMoznost6.isSelected() || chbMoznost7.isSelected()) {

if (chbMoznost7.isSelected()) {
chbMoznost6.setEnabled(false);
chbMoznost7.setEnabled(false);
if (!comboGroupDiscr.getSelectedItem().equals("choose")) {
panelVyberuAtributu.remove(sp);
int y = comboGroupDiscr.getSelectedIndex();
hodnotyPaneluVyberuAtributu = new Object[datoveStruktury.pocetHodnotAtributu[y]];
int x = 1;
while (!datoveStruktury.frekvence[x][y][1].equals("")) {
hodnotyPaneluVyberuAtributu[x-1] = datoveStruktury.frekvence[x][y][1];
x++;
}

sp = new SelectorPanel(hodnotyPaneluVyberuAtributu);
panelVyberuAtributu.setBorder(BorderFactory.createLineBorder(Color.black, 1));
panelVyberuAtributu.add(sp);
labelVyber3.setText("New name for value");
labelVyber3.setEnabled(true);
tfVyber3.setEnabled(true);
tlacGroupingConn.setEnabled(true);
tlacGroupingNewAttr.setEnabled(true);
tlacConfirmG.setEnabled(false);
comboGroupDiscr.setEnabled(false);
f.setVisible(true);
}
else {
JOptionPane.showMessageDialog(null, "You did not choose attribute... Use available combobox in middle left. ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}

}


if (chbMoznost6.isSelected()) {
chbMoznost6.setEnabled(false);
chbMoznost7.setEnabled(false);
tlacConfirmG.setEnabled(false);
comboGroupDiscr.setEnabled(false);
GroupClassSens gcs = new GroupClassSens();
int pocetVybranychAtributu = sp.selectedList.getModel().getSize();
if (pocetVybranychAtributu < 1) {
JOptionPane.showMessageDialog(null, "You did not choose any attribute... ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
else {
tlacGroupingConn.setEnabled(true);

Object[] vybraneAtributy = sp.selectedModel.getValues();
int y = 0;
for (int z = 0; z < pocetVybranychAtributu; z++) {
 for (int i = 1; i <= datoveStruktury.pocetSloupcuSouboru; i++) {
if ( ((String)vybraneAtributy[z]).equals(datoveStruktury.stavData[1][i])) {
 y = i;
 break;
 }
 }


gcs.spocitejAtribut(datoveStruktury.stavData, datoveStruktury.frekvence, datoveStruktury.pocetRadkuSouboru, y, datoveStruktury.typAtributu[1][y], datoveStruktury.pocetHodnotAtributu[y], datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil], datoveStruktury.vybranyCil, datoveStruktury.vybranaVaha, datoveStruktury.pocetSloupcuSouboru, datoveStruktury.chi );
datoveStruktury.stavData = gcs.stav;
oknoVysledku.setText(oknoVysledku.getText() + "\n\n Grouping done... ");
}
}
}

}
else {
JOptionPane.showMessageDialog(null, "You did not choose type of grouping... Please, choose Class Sensitive or User given  in middle left. ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
}
};

/**
 * Vlastn spojen hodnot pomoc procedury Grouping
 */

class provedGroupingConn implements ActionListener {
public void actionPerformed (ActionEvent e) {
int pocetVybranychAtributu = sp.selectedList.getModel().getSize();
Object[] vybraneAtributy = sp.selectedModel.getValues();
int y = comboGroupDiscr.getSelectedIndex();

int delkaNahrady = tfVyber3.getText().length();
if (delkaNahrady != 0) {
String nahrada = tfVyber3.getText();
try {
double nahradaTest = Double.parseDouble(nahrada);
}
catch (NumberFormatException epgc) {
datoveStruktury.typAtributu[2][y] = "text";

}

for (int z = 0; z < pocetVybranychAtributu; z++) {
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++ ) {
if ( ((String)vybraneAtributy[z]).equals(datoveStruktury.stavData[x][y])) {
datoveStruktury.stavData[x][y] = nahrada;  
}
 
}
}

DataDescription dataDes = new DataDescription();
dataDes.popis(datoveStruktury.stavData, datoveStruktury.pocetRadkuSouboru, datoveStruktury.pocetSloupcuSouboru, comboVaha.getSelectedIndex(), datoveStruktury.typAtributu );

oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Data Description done...  ");
datoveStruktury.frekvence = dataDes.getFrekvence();
datoveStruktury.popisStatistika = dataDes.getVysledkyPopisStat();
datoveStruktury.pocetHodnotAtributu = dataDes.getPocetHodnotAtributu();
datoveStruktury.hodnotyModus = dataDes.getHodnotyModus();

panelVyberuAtributu.remove(sp);
hodnotyPaneluVyberuAtributu = new Object[datoveStruktury.pocetHodnotAtributu[y]];
int x = 1;
while (!datoveStruktury.frekvence[x][y][1].equals("")) {
hodnotyPaneluVyberuAtributu[x-1] = datoveStruktury.frekvence[x][y][1];
x++;
}
sp = new SelectorPanel(hodnotyPaneluVyberuAtributu);
panelVyberuAtributu.add(sp);
tfVyber3.setText("");

f.setVisible(true);
oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Grouping done...");
}
else {
JOptionPane.showMessageDialog(null, "You did not choose new name for connected values ...  ", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}

}
};

class provedGroupingNewAttr implements ActionListener {
public void actionPerformed (ActionEvent e) {
tlacConfirmG.setEnabled(true);
tlacGroupingConn.setEnabled(false);
comboGroupDiscr.setEnabled(true);
tlacGroupingNewAttr.setEnabled(false);
}
};


/**
 * Deaktivace pol pro specifikaci parametr procedury Grouping
 */

class provedDeaktivujGrouping implements ActionListener {
public void actionPerformed (ActionEvent e) {
setupF();
setupT();

panelVyberuAtributu.remove(sp);
hodnotyPaneluVyberuAtributu = datoveStruktury.jmenaAtributu;
sp = new SelectorPanel(hodnotyPaneluVyberuAtributu);
panelVyberuAtributu.add(sp);
f.setVisible(true);

}
};


/**
 * Oeten chybjcch hodnot - Ignore rows
 */

class provedM2 implements ItemListener {
public void itemStateChanged (ItemEvent e) {
int vyber = e.getStateChange();
if (vyber == 1) {
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
boolean odradkuj = true;
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++ ) {
if (!datoveStruktury.missingRows.contains(x)) {
odradkuj = true;
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
vystup.print("" + datoveStruktury.stavData[x][y] + ";");
}
}
else {
odradkuj = false;
}
if (odradkuj) {
vystup.println();
}
}
vystup.close();
}
catch (IOException ee) {
oknoVysledku.setText(oknoVysledku.getText() + "\n Output problem");
}
}
}
oknoVysledku.setText(oknoVysledku.getText() + "\n" + "New file without rows with missing values was created... \n You can use Save file to save it. ");
setupT();
chbMoznost2.setEnabled(false);
chbMoznost3.setEnabled(false);
chbMoznost4.setEnabled(false);
chbMoznost5.setEnabled(false);
tlacHandlingMissingValues.setEnabled(false);

DataDescription dataDes = new DataDescription();
dataDes.popis(datoveStruktury.stavData, datoveStruktury.pocetRadkuSouboru, datoveStruktury.pocetSloupcuSouboru, datoveStruktury.vybranaVaha, datoveStruktury.typAtributu );

}
};

/**
 * Oeten chybjcch hodnot - Most frequent
 */

class provedM3 implements ItemListener {
public void itemStateChanged (ItemEvent e) {
int vyber = e.getStateChange();
boolean noMode = false;
if (vyber == 1) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if (datoveStruktury.missingColumns.contains(y) && !datoveStruktury.hodnotyModus[y].equals("No mode")) {
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
if (datoveStruktury.missingRows.contains(x) && datoveStruktury.stavData[x][y].equals("DPT - MISSING VALUE")) {
datoveStruktury.stavData[x][y] = datoveStruktury.hodnotyModus[y];

}
}
}
if (datoveStruktury.hodnotyModus[y].equals("No mode")) {
oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Attribute " + datoveStruktury.stavData[1][y] + " does not have mode...");
noMode = true;
}
}
}
oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Replacement done...");
setupT();
chbMoznost2.setEnabled(false);
chbMoznost3.setEnabled(false);
chbMoznost4.setEnabled(false);
chbMoznost5.setEnabled(false);
if (!noMode) {
tlacHandlingMissingValues.setEnabled(false);
}
DataDescription dataDes = new DataDescription();
dataDes.popis(datoveStruktury.stavData, datoveStruktury.pocetRadkuSouboru, datoveStruktury.pocetSloupcuSouboru, datoveStruktury.vybranaVaha, datoveStruktury.typAtributu );

}
};

/**
 * Oeten chybjcch hodnot - Proportional
 */

class provedM4 implements ItemListener {
public void itemStateChanged (ItemEvent e) {

int vyber = e.getStateChange();
if (vyber == 1) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if (datoveStruktury.missingColumns.contains(y)) {
double kolikMissing = 0;
double kolikMissProc = 0;
TreeMap<Double,Integer> frek2set = new TreeMap<Double,Integer>();
double sumaFrekProc = 0;


for (int w = 1; w <= datoveStruktury.pocetHodnotAtributu[y]; w++) {
if (datoveStruktury.frekvence[w][y][1].equals("DPT - MISSING VALUE")) {
kolikMissing = Double.parseDouble(datoveStruktury.frekvence[w][y][2]);

kolikMissProc = (100 - (100 * Double.parseDouble(datoveStruktury.frekvence[w][y][3])))/kolikMissing;
datoveStruktury.frekvence[w][y][3] = "0";
}
double frek3 = Double.parseDouble(datoveStruktury.frekvence[w][y][3]);
Integer freq = frek2set.get(frek3);

frek2set.put(frek3,  (freq == null) ? 1 : freq + 1); 

}

for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
if (datoveStruktury.missingRows.contains(x) && datoveStruktury.stavData[x][y].equals("DPT - MISSING VALUE")) {

try {
for (int w = 1; w <= datoveStruktury.pocetHodnotAtributu[y]; w++) {


if (Double.parseDouble(datoveStruktury.frekvence[w][y][3]) == frek2set.lastKey() ) {

datoveStruktury.stavData[x][y] = datoveStruktury.frekvence[w][y][1];

Integer freq = frek2set.get(Double.parseDouble(datoveStruktury.frekvence[w][y][3]));
if (freq == 1) {
frek2set.remove(Double.parseDouble(datoveStruktury.frekvence[w][y][3]));
}
else {
frek2set.put(Double.parseDouble(datoveStruktury.frekvence[w][y][3]),  freq - 1);
}

datoveStruktury.frekvence[w][y][3] = "" + (Double.parseDouble(datoveStruktury.frekvence[w][y][3]) - kolikMissProc);
if (Double.parseDouble(datoveStruktury.frekvence[w][y][3]) > 0) {
freq = frek2set.get(Double.parseDouble(datoveStruktury.frekvence[w][y][3]));
frek2set.put(Double.parseDouble(datoveStruktury.frekvence[w][y][3]),  freq + 1);
}
break;
}

}
}
catch (NoSuchElementException es) {
}

}
}
}
}
}
setupT();
chbMoznost2.setEnabled(false);
chbMoznost3.setEnabled(false);
chbMoznost4.setEnabled(false);
chbMoznost5.setEnabled(false);
tlacHandlingMissingValues.setEnabled(false);
oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Proportional replacement / done...");
DataDescription dataDes = new DataDescription();
dataDes.popis(datoveStruktury.stavData, datoveStruktury.pocetRadkuSouboru, datoveStruktury.pocetSloupcuSouboru, datoveStruktury.vybranaVaha, datoveStruktury.typAtributu );

}
};

/**
 * Oeten chybjcch hodnot - Any value
 */


class provedM5 implements ItemListener {
public void itemStateChanged (ItemEvent e) {
int vyber = e.getStateChange();
if (vyber == 1) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if (datoveStruktury.missingColumns.contains(y)) {
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
if (datoveStruktury.missingRows.contains(x) && datoveStruktury.stavData[x][y].equals("DPT - MISSING VALUE")) {
int nahoda = (int)((Math.random() * datoveStruktury.pocetHodnotAtributu[y]) + 1);
String nahrada = datoveStruktury.frekvence[nahoda][y][1];
datoveStruktury.stavData[x][y] = nahrada;

}
}
}
}
}
oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Replacement done...");
setupT();
chbMoznost2.setEnabled(false);
chbMoznost3.setEnabled(false);
chbMoznost4.setEnabled(false);
chbMoznost5.setEnabled(false);
tlacHandlingMissingValues.setEnabled(false);
DataDescription dataDes = new DataDescription();
dataDes.popis(datoveStruktury.stavData, datoveStruktury.pocetRadkuSouboru, datoveStruktury.pocetSloupcuSouboru, datoveStruktury.vybranaVaha, datoveStruktury.typAtributu );

}
};

/**
 * Class sensitive grouping - aktivace a deaktivace comba
 */

class provedM6 implements ItemListener {
public void itemStateChanged (ItemEvent e) {
int vyber = e.getStateChange();
if (vyber == 1) {
comboGroupDiscr.setEnabled(false);
}
}
};

/**
 * User given grouping - aktivace a deaktivace comba
 */

class provedM7 implements ItemListener {
public void itemStateChanged (ItemEvent e) {
int vyber = e.getStateChange();
if (vyber == 1) {

comboGroupDiscr.removeAllItems();
int pocetSloupcu = datoveStruktury.pocetSloupcuSouboru;
String vybranaVaha = (String)comboVaha.getSelectedItem();
for (int i = 0; i<= pocetSloupcu; i++) {
if (!datoveStruktury.jmenaAtributuCil[i].equals(vybranaVaha)) {
comboGroupDiscr.addItem(datoveStruktury.jmenaAtributuCil[i]);
}
}

comboGroupDiscr.setEnabled(true);
}
}
};

/**
 * Aktivace a deaktivace pol po proveden procedur Row selection nebo Splitting
 */

class provedtlacDeaktivujRowSelSplit implements ActionListener {
public void actionPerformed (ActionEvent e) {
setupF();
setupT();


}
};

} // class    

