import java.io.*;
import java.util.*;
import javax.swing.*;

/************************************
 * Trida nacte soubor ve formatu CSV (oddelovac je oddelovac).
 * Nejdrive zjisti, kolik ma soubor radku, potom nacita jednotlive radky do pole.
 * Rozmery pole jsou urceny zjistenym poctem radku a prvnim radkem. 
 * Misto prazdnych poli doplni "DPT - MISSING VALUE"
 */
public class NactiCSVSoubor {


public NactiCSVSoubor()
    {    
    }

/***********************************
 * Atributy tridy
 */     
private String [][] stav;
private int pocetRadku = 0;
private int pocetSloupcu = 1;
TreeSet<Integer> missingRows = new TreeSet<Integer>(); 
TreeSet<Integer> missingColumns = new TreeSet<Integer>(); 

/***********************************
 * Vraci nacteny soubor ve formatu dvourozmerneho pole typu String. 
 */
public String[][] getStav() {
return stav;
}
/***********************************
 * Vraci pocet radku nacteneho souboru. Pocet zahrnuje hlavicku.
 */
public int getPocetRadku() {
return pocetRadku;
}

/***********************************
 * Vraci pocet sloupcu nacteneho souboru.
 */
public int getPocetSloupcu() {
return pocetSloupcu;
}

/**********************************
 * Metoda provadejici nacteni
 * @param soubor Jmeno souboru
 * @param oddelovac Strednik nebo carka
 */ 
public void nacti(String soubor, String oddelovac) {


try {
BufferedReader vstup1 = new BufferedReader(new FileReader(soubor)); 
String radek;
radek= vstup1.readLine();
String prvniRadek = radek;
while (radek != null) {
  pocetRadku++;
  radek= vstup1.readLine();
}

//String oddelovac = ";";
int delkaRadku = prvniRadek.length();
for (int i = 1; i <= delkaRadku; i++) {
if (prvniRadek.substring(i-1,i).equals(oddelovac)) {
pocetSloupcu++;
}
}
vstup1.close();

stav = new String[pocetRadku+1][pocetSloupcu+1];

int x = 1;
int y = 1;
int predchoziOddelovac = 0;

BufferedReader vstup = new BufferedReader(new FileReader(soubor)); 
radek= vstup.readLine();
while (radek != null) {

delkaRadku = radek.length();
int posledniOddelovac=delkaRadku;

for (int i = 1; i <= delkaRadku; i++) {
if (radek.substring(i-1,i).equals(oddelovac)) {
stav[x][y] = radek.substring(predchoziOddelovac,i-1);
if ((stav[x][y]).equals("")) {
stav[x][y] = "DPT - MISSING VALUE";
missingRows.add(x);
missingColumns.add(y);

}
y++;
predchoziOddelovac=i;
}

}
stav[x][y]=radek.substring(predchoziOddelovac,posledniOddelovac);

if (x == 1) {
pocetSloupcu = y;
}
x++;
y=1;
predchoziOddelovac = 0;
radek=vstup.readLine();
} // while


vstup.close();
} // try

catch (FileNotFoundException e) {
JOptionPane.showMessageDialog(null, "File does not exist!", "No file", JOptionPane.INFORMATION_MESSAGE);
}

catch (IOException e){
JOptionPane.showMessageDialog(null, "Input problem", "Input problem", JOptionPane.INFORMATION_MESSAGE);
}
} // nacti



} // class
    
    

