import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;

/**
 * Tda, kter vybere jen st dat ze vstupnho souboru.
 */
public class Sampling
{
    public Sampling()
    {
    }
    
DataKapsa datoveStruktury;    
 
/**
 * Metoda, kter vybere jen st dat ze vstupnho souboru.
 * @param textRel obsah pole pro relativn podl vybranch dat
 * @param textAbs obsah pole pro absolutn poet vybranch dat
 * @param textRepeat obsah pole kolikrt opakovat
 * @param stratif volba stratifikovanho vbru
 * @param celaTrida volba cel tdy
 */ 

public void sample(String textRel, String textAbs, String textRepeat, boolean stratif, String celaTrida) {
datoveStruktury = datoveStruktury.getInstance();    
int cil = datoveStruktury.vybranyCil;

if (celaTrida.equals("whole class")) {
double relativne = 0;
double absolutne = 0;
try {
if (!textRel.equals("")) {
relativne = Double.parseDouble(textRel);
if (relativne > 99 ) {relativne = 66;}
if (relativne < 0 ) {relativne = 66;}
}
if (!textAbs.equals("")) {
absolutne = Double.parseDouble(textAbs);
if (absolutne > datoveStruktury.pocetRadkuSouboru ) {absolutne = 0; relativne = 66;}
if (absolutne < 1 ) {absolutne = 0; relativne = 66;}
}
}
catch (NumberFormatException ee) {
JOptionPane.showMessageDialog(null, "Wrong input! Please, enter integer value!", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
datoveStruktury.dataTrenovaci = new String[datoveStruktury.pocetRadkuSouboru+1][datoveStruktury.pocetSloupcuSouboru+1];


double posunovac = 1;
if (absolutne > 0 && !stratif) {

double pocetDatCelkem;
if (datoveStruktury.vybranaVaha == 0) {
pocetDatCelkem = datoveStruktury.pocetRadkuSouboru - 1;
}
else {
pocetDatCelkem = (double)datoveStruktury.sumaVah;
}
double pocetDatTrenink = absolutne;

double podilDatTrenink = (double)pocetDatTrenink/pocetDatCelkem;
pocetDatTrenink = 0;

for (int x = 2; x <= pocetDatCelkem; x++ ) {
double nahodneCislo = Math.random();
if (datoveStruktury.vybranaVaha != 0) {
posunovac = Double.parseDouble(datoveStruktury.stavData[x][datoveStruktury.vybranaVaha]);
}
if (((nahodneCislo < podilDatTrenink) && (pocetDatTrenink < absolutne ))  ) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[x][y] = datoveStruktury.stavData[x][y];
}

pocetDatTrenink = pocetDatTrenink + posunovac;
}



}
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[1][y] = datoveStruktury.stavData[1][y];

}
uloz();
}

else if (absolutne > 0  && stratif){
double pocetDatCelkem;
if (datoveStruktury.vybranaVaha == 0) {
pocetDatCelkem = datoveStruktury.pocetRadkuSouboru - 1;
}
else {
pocetDatCelkem = (double)datoveStruktury.sumaVah;
}
double pocetDatTrenink = absolutne;
double pocetDatTrenink1[][] = new double [datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil] +1][3];
double podilDatTrenink = (double)pocetDatTrenink/pocetDatCelkem;
double sumaTrenink = 0;
for (int i = 1; i <= datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil]; i++){ 
pocetDatTrenink1[i][1] = (double)Math.round(Double.parseDouble(datoveStruktury.frekvence[i][datoveStruktury.vybranyCil][2]) * podilDatTrenink);
sumaTrenink = sumaTrenink + pocetDatTrenink1[i][1];
}

pocetDatTrenink = 0;
int cilNaRadkuX = 0;
for (int x = 2; x <= pocetDatCelkem; x++ ) {
if (datoveStruktury.vybranaVaha != 0) {
posunovac = Double.parseDouble(datoveStruktury.stavData[x][datoveStruktury.vybranaVaha]);
}

for (int i = 1; i <= datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil]; i++){ 
if (datoveStruktury.stavData[x][datoveStruktury.vybranyCil].equals(datoveStruktury.frekvence[i][datoveStruktury.vybranyCil][1])) {
cilNaRadkuX = i;
break;
}
}
double nahodneCislo = Math.random();

if (((nahodneCislo < podilDatTrenink) && (pocetDatTrenink < absolutne ) && (pocetDatTrenink1[cilNaRadkuX][1] > pocetDatTrenink1[cilNaRadkuX][2]))  ) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[x][y] = datoveStruktury.stavData[x][y];
}
pocetDatTrenink = pocetDatTrenink + posunovac;
pocetDatTrenink1[cilNaRadkuX][2] = pocetDatTrenink1[cilNaRadkuX][2] + posunovac;
}

}
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[1][y] = datoveStruktury.stavData[1][y];

}

uloz();
}

else if (relativne > 0  && !stratif){
double pocetDatTreninkAbsolutne;

if (datoveStruktury.vybranaVaha == 0) {
pocetDatTreninkAbsolutne = Math.round((datoveStruktury.pocetRadkuSouboru - 1) * relativne/100);

}
else{
pocetDatTreninkAbsolutne = Math.round((datoveStruktury.sumaVah) * relativne/100);

}

double podilDatTrenink = (double)relativne/100;
double pocetDatTrenink = 0;

for (int x = 2; x <= datoveStruktury.pocetRadkuSouboru; x++ ) {
double nahodneCislo = Math.random();
if (datoveStruktury.vybranaVaha != 0) {
posunovac = Double.parseDouble(datoveStruktury.stavData[x][datoveStruktury.vybranaVaha]);
}

if (((nahodneCislo < podilDatTrenink) && (pocetDatTrenink < pocetDatTreninkAbsolutne )) ) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[x][y] = datoveStruktury.stavData[x][y];
}
pocetDatTrenink = pocetDatTrenink + posunovac;
}

}
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[1][y] = datoveStruktury.stavData[1][y];

}
uloz();
}

else if (relativne > 0  && stratif){
double pocetDatTreninkAbsolutne;

if (datoveStruktury.vybranaVaha == 0) {
pocetDatTreninkAbsolutne = Math.round((datoveStruktury.pocetRadkuSouboru - 1) * relativne/100);
}
else{
pocetDatTreninkAbsolutne = Math.round((datoveStruktury.sumaVah) * relativne/100);
}

double pocetDatTrenink1[][] = new double [datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil] +1][3];
double podilDatTrenink = (double)relativne/100;
double sumaTrenink = 0;
for (int i = 1; i <= datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil]; i++){ 
pocetDatTrenink1[i][1] = (double)Math.round(Double.parseDouble(datoveStruktury.frekvence[i][datoveStruktury.vybranyCil][2]) * podilDatTrenink);
sumaTrenink = sumaTrenink + pocetDatTrenink1[i][1];
}

double pocetDatTrenink = 0;

String aktualniCil = "";
for (int x = 2; x <= datoveStruktury.pocetRadkuSouboru; x++ ) {
double nahodneCislo = Math.random();
if (datoveStruktury.vybranaVaha != 0) {
posunovac = Double.parseDouble(datoveStruktury.stavData[x][datoveStruktury.vybranaVaha]);
}

aktualniCil = datoveStruktury.stavData[x][datoveStruktury.vybranyCil];
int kteryCil = 0;
for (int w = 1; w <= datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil]; w++ ) {
if ((datoveStruktury.frekvence[w][datoveStruktury.vybranyCil][1]).equals(aktualniCil)) {
kteryCil = w;
break;
}
}

if (((nahodneCislo < podilDatTrenink) && (pocetDatTrenink < pocetDatTreninkAbsolutne ) && (pocetDatTrenink1[kteryCil][1] > pocetDatTrenink1[kteryCil][2]))  ) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[x][y] = datoveStruktury.stavData[x][y];
}
pocetDatTrenink = pocetDatTrenink + posunovac;
pocetDatTrenink1[kteryCil][2] = pocetDatTrenink1[kteryCil][2] + posunovac;
}

}
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[1][y] = datoveStruktury.stavData[1][y];

}
uloz();
}


else {
JOptionPane.showMessageDialog(null, "There is something wrong with the input...", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}


} // if (celaTrida.equals("whole class")) 

// if neni (celaTrida.equals("whole class")) 
else {
double relativne = 0;
double absolutne = 0;
try {
if (!textRel.equals("")) {
relativne = Double.parseDouble(textRel);
if (relativne > 99 ) {relativne = 66;}
if (relativne < 0 ) {relativne = 66;}
}
if (!textAbs.equals("")) {
int kde = 0;
for (int x = 1; x <= datoveStruktury.pocetHodnotAtributu[cil]; x++) {
if (datoveStruktury.frekvence[x][cil][1].equals(celaTrida)) {
kde = x;
}
}
absolutne = Double.parseDouble(textAbs);
double absolutne2 = Double.parseDouble(textAbs) - Double.parseDouble(datoveStruktury.frekvence[kde][cil][2]);
if (absolutne > datoveStruktury.pocetRadkuSouboru ) {absolutne = 0; relativne = 66;}
if (absolutne < 1 || absolutne2 < 1) {absolutne = Double.parseDouble(datoveStruktury.frekvence[kde][cil][2]);}
}
}
catch (NumberFormatException ee) {
JOptionPane.showMessageDialog(null, "Wrong input! Please, enter integer value!", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
datoveStruktury.dataTrenovaci = new String[datoveStruktury.pocetRadkuSouboru+1][datoveStruktury.pocetSloupcuSouboru+1];


double posunovac = 1;
if (absolutne > 0 && !stratif) {

double pocetDatCelkem;
if (datoveStruktury.vybranaVaha == 0) {
pocetDatCelkem = datoveStruktury.pocetRadkuSouboru - 1;
}
else {
pocetDatCelkem = (double)datoveStruktury.sumaVah;
}
double pocetDatTrenink = absolutne;

double podilDatTrenink = (double)pocetDatTrenink/pocetDatCelkem;
pocetDatTrenink = 0;

for (int x = 2; x <= pocetDatCelkem; x++ ) {
double nahodneCislo = Math.random();
if (datoveStruktury.vybranaVaha != 0) {
posunovac = Double.parseDouble(datoveStruktury.stavData[x][datoveStruktury.vybranaVaha]);
}
if (((nahodneCislo < podilDatTrenink) && (pocetDatTrenink < absolutne )) || datoveStruktury.stavData[x][cil].equals(celaTrida)  ) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[x][y] = datoveStruktury.stavData[x][y];
}

pocetDatTrenink = pocetDatTrenink + posunovac;
}



}
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[1][y] = datoveStruktury.stavData[1][y];

}
uloz();
}


else if (relativne > 0  && !stratif){
double pocetDatTreninkAbsolutne;

if (datoveStruktury.vybranaVaha == 0) {
pocetDatTreninkAbsolutne = Math.round((datoveStruktury.pocetRadkuSouboru - 1) * relativne/100);

}
else{
pocetDatTreninkAbsolutne = Math.round((datoveStruktury.sumaVah) * relativne/100);

}

double podilDatTrenink = (double)relativne/100;
double pocetDatTrenink = 0;

for (int x = 2; x <= datoveStruktury.pocetRadkuSouboru; x++ ) {
double nahodneCislo = Math.random();
if (datoveStruktury.vybranaVaha != 0) {
posunovac = Double.parseDouble(datoveStruktury.stavData[x][datoveStruktury.vybranaVaha]);
}

if (((nahodneCislo < podilDatTrenink) && (pocetDatTrenink < pocetDatTreninkAbsolutne )) || datoveStruktury.stavData[x][cil].equals(celaTrida)) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[x][y] = datoveStruktury.stavData[x][y];
}
pocetDatTrenink = pocetDatTrenink + posunovac;
}

}
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[1][y] = datoveStruktury.stavData[1][y];

}
uloz();
}



else {
JOptionPane.showMessageDialog(null, "There is something wrong with the input...", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
}

} // split


/**
 * Metoda, kter ulo vybran vzorek dat do souboru.
 */

public void uloz() {
datoveStruktury = datoveStruktury.getInstance();    
Frame fr = new Frame();
fr.setLocation(500,500);
JFileChooser fc = new JFileChooser();
fc.setDialogTitle("Save sample data");
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

double stavVyberu = fc.showSaveDialog(fr);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
boolean odradkuj = false;
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if (datoveStruktury.dataTrenovaci[x][y] != null) {
vystup.print("" + datoveStruktury.dataTrenovaci[x][y] + ";");
odradkuj = true;
}
}
if (odradkuj) {
vystup.println();
odradkuj = false;
}
}
vystup.close();
}
catch (IOException ee) {
JOptionPane.showMessageDialog(null, "Input problem", "Input problem", JOptionPane.INFORMATION_MESSAGE);

}
}


fr.dispose();

} // uloz


} // class
