import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;


public class Grafika
{

Frame f;
JButton tlacNactiSoubor;
JButton tlacVycistiOknoVysledku;
JButton tlacUlozOknoVysledku;
JButton tlacUlozVytvorenySoubor;
JButton tlacVyberVahu;
JButton tlacVyberCil;
JButton tlacVyberCilOK;
JButton tlacZobrazDataDescription;
JButton tlacZobrazNoiseEvaluation;
JButton tlacZobrazAttributeRelevance;
JButton tlacZobrazAttributeDependence;
JButton tlacDiscretization;
JButton tlacGrouping;
JButton tlacHandlingMissingValues;
JButton tlacUlozVybraneSloupce;
JButton tlacUlozVybraneRadky;
JButton tlacAktivujVyberRadku;
JButton tlacAktivujSplitting;
JButton tlacSplitting;

JLabel labelSoubor;
JLabel labelPanelVyberuAtributu;
JLabel labelPanelVyberu;
JLabel labelVyber1;
JLabel labelVyber2;
JLabel labelVyber3;

JTextField tfVyber1;
JTextField tfVyber2;
JTextField tfVyber3;

JPanel panelVyberuAtributu;

static JTextArea oknoVysledku;

JScrollPane posuvnik;

SelectorPanel sp;

Object[] hodnotyPaneluVyberuAtrubutu;

JComboBox comboVaha;
JComboBox comboCil;

JCheckBox chbZaradVyrad1;

CheckboxGroup chbgOddelovac;
Checkbox chbStrednik;
Checkbox chbCarka;

DataKapsa datoveStruktury;

public Grafika()
    {
    }

    
public void makeLayout() {
f = new Frame("Data preprocessing system for datamining");
f.addWindowListener(new WindowAdapter () {
public void windowClosing (WindowEvent e) {
System.exit(0);
}
});

f.setLayout(new GridBagLayout());


tlacNactiSoubor = new JButton("Open file");
makeComponent(f, tlacNactiSoubor, 0, 0, 1, 1, 0.0, 0.0);
tlacNactiSoubor.addActionListener(new provedNacteniSouboru());
tlacVycistiOknoVysledku = new JButton("Clear Screen");
makeComponent(f, tlacVycistiOknoVysledku, 4, 13, 1, 1, 0.0, 0.0);
tlacVycistiOknoVysledku.addActionListener(new provedSmazatVysledky());
tlacUlozOknoVysledku = new JButton("Save Screen");
makeComponent(f, tlacUlozOknoVysledku, 5, 13, 1, 1, 0.0, 0.0);
tlacUlozOknoVysledku.addActionListener(new provedUlozVysledky());
tlacUlozVytvorenySoubor = new JButton("Save file");
makeComponent(f, tlacUlozVytvorenySoubor, 6, 13, 1, 1, 0.0, 0.0);
tlacUlozVytvorenySoubor.addActionListener(new provedUlozSoubor());
tlacVyberVahu = new JButton("Choose float");
makeComponent(f, tlacVyberVahu, 0, 1, 1, 1, 0.0, 0.0);
tlacVyberVahu.addActionListener(new provedVaha());
tlacVyberCil = new JButton("Choose target");
makeComponent(f, tlacVyberCil, 0, 2, 1, 1, 0.0, 0.0);
tlacVyberCil.addActionListener(new provedCil());
tlacVyberCilOK = new JButton("Confirm target and weight choice");
makeComponent(f, tlacVyberCilOK, 3, 2, 1, 1, 0.0, 0.0);
tlacVyberCilOK.addActionListener(new provedCilOK());
tlacZobrazDataDescription = new JButton("Show data description");
makeComponent(f, tlacZobrazDataDescription, 3, 6, 1, 1, 0.0, 0.0);
tlacZobrazDataDescription.addActionListener(new provedZobrazDD());
tlacZobrazNoiseEvaluation = new JButton("Show noise evaluation");
makeComponent(f, tlacZobrazNoiseEvaluation, 3, 7, 1, 1, 0.0, 0.0);
tlacZobrazAttributeRelevance = new JButton("Show attribute relevance");
makeComponent(f, tlacZobrazAttributeRelevance, 3, 8, 1, 1, 0.0, 0.0);
tlacZobrazAttributeRelevance.addActionListener(new provedAttributeRelevance());
tlacZobrazAttributeDependence = new JButton("Show attribute dependence");
makeComponent(f, tlacZobrazAttributeDependence, 3, 9, 1, 1, 0.0, 0.0);
tlacZobrazAttributeDependence.addActionListener(new provedAttributeDependence());
tlacDiscretization = new JButton("Discretization");
makeComponent(f, tlacDiscretization, 3, 10, 1, 1, 0.0, 0.0);
tlacGrouping = new JButton("Grouping");
makeComponent(f, tlacGrouping, 3, 11, 1, 1, 0.0, 0.0);
tlacHandlingMissingValues = new JButton("Handling Missing Values");
makeComponent(f, tlacHandlingMissingValues, 3, 12, 1, 1, 0.0, 0.0);
labelSoubor = new JLabel("File: ");
makeComponent(f, labelSoubor, 1, 0, 4, 1, 0.0, 0.0);
labelSoubor.setVisible(false);


labelPanelVyberuAtributu = new JLabel("Choose attributes");
makeComponent(f, labelPanelVyberuAtributu, 0, 3, 1, 1, 0.0, 0.0);
comboVaha = new JComboBox();
makeComponent(f, comboVaha, 1, 1, 1, 1, 0.0, 0.0);
comboCil = new JComboBox();
makeComponent(f, comboCil, 1, 2, 1, 1, 0.0, 0.0);
tlacUlozVybraneSloupce = new JButton("Save columns");
makeComponent(f, tlacUlozVybraneSloupce, 7, 13, 1, 1, 0.0, 0.0);
tlacUlozVybraneSloupce.addActionListener(new provedUlozVybraneSloupce());
tlacAktivujVyberRadku = new JButton("Activate rows selection");
makeComponent(f, tlacAktivujVyberRadku, 5, 14, 1, 1, 0.0, 0.0);
tlacAktivujVyberRadku.addActionListener(new provedAktivujVyberRadku());
tlacUlozVybraneRadky = new JButton("Save rows");
makeComponent(f, tlacUlozVybraneRadky, 6, 14, 1, 1, 0.0, 0.0);
tlacUlozVybraneRadky.addActionListener(new provedUlozVybraneRadky());
tfVyber1 = new JTextField(7);
makeComponent(f, tfVyber1, 1, 11, 1, 1, 0.0, 0.0);
tfVyber2 = new JTextField(7);
makeComponent(f, tfVyber2, 1, 12, 1, 1, 0.0, 0.0);
tfVyber3 = new JTextField(7);
makeComponent(f, tfVyber3, 1, 13, 1, 1, 0.0, 0.0);
labelPanelVyberu = new JLabel("Not active possibilities");
makeComponent(f, labelPanelVyberu, 0, 10, 1, 1, 0.0, 0.0);
labelVyber1 = new JLabel("...");
makeComponent(f, labelVyber1, 0, 11, 1, 1, 0.0, 0.0);
labelVyber2 = new JLabel("...");
makeComponent(f, labelVyber2, 0, 12, 1, 1, 0.0, 0.0);
labelVyber3 = new JLabel("...");
makeComponent(f, labelVyber3, 0, 13, 1, 1, 0.0, 0.0);
chbZaradVyrad1 = new JCheckBox("");
makeComponent(f, chbZaradVyrad1, 0, 14, 1, 1, 0.0, 0.0);
tlacAktivujSplitting = new JButton("Activate splitting");
makeComponent(f, tlacAktivujSplitting, 5, 15, 1, 1, 0.0, 0.0);
tlacAktivujSplitting.addActionListener(new provedAktivujSplitting());
tlacSplitting = new JButton("Splitt");
makeComponent(f, tlacSplitting, 6, 15, 1, 1, 0.0, 0.0);
tlacSplitting.addActionListener(new provedSplitting());
chbgOddelovac = new CheckboxGroup();
chbStrednik = new Checkbox("Semicolon delimited ", chbgOddelovac, true);
chbCarka = new Checkbox("Comma delimited ", chbgOddelovac, false);
makeComponent(f, chbStrednik, 1, 0, 1, 1, 0.0, 0.0);
makeComponent(f, chbCarka, 3, 0, 1, 1, 0.0, 0.0);

oknoVysledku = new JTextArea();
posuvnik = new JScrollPane(oknoVysledku);
makeComponent(f, posuvnik, 5, 5, 3, 6, 0.0, 0.0);
panelVyberuAtributu = new JPanel();
makeComponent(f, panelVyberuAtributu, 0, 4, 2, 6, 0.0, 0.0);
panelVyberuAtributu.setLayout(new BorderLayout());

setup();
f.pack();
f.setVisible(true);
double vyskaOkna = f.getHeight();
double sirkaOkna = f.getWidth();
if (vyskaOkna < 700) {
f.setSize((int)sirkaOkna, 700);
}

}

  void makeComponent(Container cont, Object arg, int x, int y, int w, int h, double weightx, double weighty) {
GridBagLayout gbl = (GridBagLayout)cont.getLayout();
GridBagConstraints c = new GridBagConstraints();
Component comp;

c.fill = GridBagConstraints.BOTH;
c.gridx = x;
c.gridy = y;
c.gridwidth = w;
c.gridheight = h;
c.weightx = weightx;
c.weighty = weighty;
if (arg instanceof String) {
comp = new Button((String)arg);
}
else {
comp = (Component)arg;
}
cont.add(comp);
gbl.setConstraints(comp, c);
} // makeComponent

void setup() {
oknoVysledku.setText("HELP: At first, please, choose the file you want to work with. (Press Open file.) ");
oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Then choose float and target attribute. Press Confirm float and target. " + "\n\n\n");
tlacUlozVybraneRadky.setEnabled(false);
tlacSplitting.setEnabled(false);
tlacUlozVytvorenySoubor.setEnabled(false);
tlacVyberVahu.setEnabled(false);
tlacVyberCil.setEnabled(false);
tlacVyberCilOK.setEnabled(false);
tlacZobrazDataDescription.setEnabled(false);
tlacZobrazNoiseEvaluation.setEnabled(false);
tlacZobrazAttributeRelevance.setEnabled(false);
tlacZobrazAttributeDependence.setEnabled(false);
tlacDiscretization.setEnabled(false);
tlacGrouping.setEnabled(false);
tlacHandlingMissingValues.setEnabled(false);
tlacUlozVybraneSloupce.setEnabled(false);
tlacAktivujVyberRadku.setEnabled(false);
tlacAktivujSplitting.setEnabled(false);
tfVyber1.setEnabled(false);
tfVyber2.setEnabled(false);
tfVyber3.setEnabled(false);
comboVaha.setEnabled(false);
comboCil.setEnabled(false);
chbZaradVyrad1.setEnabled(false);
}


class provedNacteniSouboru implements ActionListener {
public void actionPerformed (ActionEvent e) {
NactiCSVSoubor csvSoubor = new NactiCSVSoubor();
datoveStruktury = datoveStruktury.getInstance();
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showOpenDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
oknoVysledku.setText(oknoVysledku.getText() + "Working with file "+ fc.getCurrentDirectory().toString() + "\\" + fc.getSelectedFile().getName());
oknoVysledku.setText(oknoVysledku.getText() + "\n" );
if (chbStrednik.getState()) {
csvSoubor.nacti(""+ fc.getCurrentDirectory().toString() +  "\\" + fc.getSelectedFile().getName(), ";");
} else {
csvSoubor.nacti(""+ fc.getCurrentDirectory().toString() +  "\\" + fc.getSelectedFile().getName(), ",");
}
//csvSoubor.isAttributeNumeric();
datoveStruktury.stavData = csvSoubor.getStav();
datoveStruktury.pocetRadkuSouboru = csvSoubor.getPocetRadku();
datoveStruktury.pocetSloupcuSouboru = csvSoubor.getPocetSloupcu();
datoveStruktury.isAttributeNumeric();
oknoVysledku.setText(oknoVysledku.getText() + "\n");
tlacVyberVahu.setEnabled(true);

labelSoubor.setText("File: "+ fc.getCurrentDirectory().toString() +  "\\" + fc.getSelectedFile().getName());
chbStrednik.setVisible(false);
chbCarka.setVisible(false);
labelSoubor.setVisible(true);
tlacVyberVahu.setEnabled(true);
}
}
};

class provedVaha implements ActionListener {
public void actionPerformed (ActionEvent e) {
datoveStruktury.zjistiAtributy();
comboVaha.removeAllItems();
int pocetSloupcu = datoveStruktury.pocetSloupcuTypuNumeric;
for (int i = 0; i< pocetSloupcu; i++) {
comboVaha.addItem(datoveStruktury.jmenaAtributuVaha[i]);
}
comboVaha.setEnabled(true);
tlacVyberCil.setEnabled(true);

}
};

class provedCil implements ActionListener {
public void actionPerformed (ActionEvent e) {
tlacVyberCilOK.setEnabled(true);
comboCil.removeAllItems();
int pocetSloupcu = datoveStruktury.pocetSloupcuSouboru;
String vybranaVaha = (String)comboVaha.getSelectedItem();
for (int i = 0; i<= pocetSloupcu; i++) {
if (!datoveStruktury.jmenaAtributuCil[i].equals(vybranaVaha)) {
comboCil.addItem(datoveStruktury.jmenaAtributuCil[i]);
}
else {
datoveStruktury.vybranaVaha = i;
}
}
comboCil.setEnabled(true);
tlacVyberCilOK.setEnabled(true);
}
};

class provedCilOK implements ActionListener {
public void actionPerformed (ActionEvent e) {
if (comboCil.getSelectedItem().equals("choose")) {
JOptionPane.showMessageDialog(null, "Please, choose target attribute!", "No target attribut", JOptionPane.INFORMATION_MESSAGE);
}
if (!comboCil.getSelectedItem().equals("choose")) {

oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Float is attribut " + comboVaha.getSelectedItem() + "\n" + "Target is atribut " + comboCil.getSelectedItem());
}

String cilS = comboCil.getSelectedItem().toString();
for (int y = 0; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if (datoveStruktury.jmenaAtributuCil[y].equals(cilS)) {
datoveStruktury.vybranyCil = y;
}
}
// naplneni panelu pro vyber atributu

hodnotyPaneluVyberuAtrubutu = datoveStruktury.jmenaAtributu;
sp = new SelectorPanel(hodnotyPaneluVyberuAtrubutu);
panelVyberuAtributu.setBorder(BorderFactory.createLineBorder(Color.black, 1));
panelVyberuAtributu.add(sp);
f.setVisible(true);

// provedeni popisne statistiky
DataDescription dataDes = new DataDescription();
dataDes.popis(datoveStruktury.stavData, datoveStruktury.pocetRadkuSouboru, datoveStruktury.pocetSloupcuSouboru, comboVaha.getSelectedIndex(), datoveStruktury.typAtributu );

oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Data Description done...  ");
datoveStruktury.frekvence = dataDes.getFrekvence();
datoveStruktury.popisStatistika = dataDes.getVysledkyPopisStat();
datoveStruktury.pocetHodnotAtributu = dataDes.getPocetHodnotAtributu();
datoveStruktury.hodnotyModus = dataDes.getHodnotyModus();

tlacUlozVytvorenySoubor.setEnabled(true);
tlacZobrazDataDescription.setEnabled(true);
tlacZobrazNoiseEvaluation.setEnabled(true);
tlacZobrazAttributeRelevance.setEnabled(true);
tlacZobrazAttributeDependence.setEnabled(true);
tlacDiscretization.setEnabled(true);
tlacGrouping.setEnabled(true);
tlacHandlingMissingValues.setEnabled(true);
tlacUlozVybraneSloupce.setEnabled(true);
tlacAktivujVyberRadku.setEnabled(true);
tlacAktivujSplitting.setEnabled(true);

}
};

class provedZobrazDD implements ActionListener {
public void actionPerformed (ActionEvent e) {
int pocetVybranychAtributu = sp.selectedList.getLastVisibleIndex() + 1;
Object[] vybraneAtributy = sp.selectedModel.getValues();
int y = 0;
for (int z = 0; z < pocetVybranychAtributu; z++) {
 for (int i = 1; i <= datoveStruktury.pocetSloupcuSouboru; i++) {
if ( ((String)vybraneAtributy[z]).equals(datoveStruktury.stavData[1][i])) {
 y = i;
 break;
 }
 }

oknoVysledku.setText(oknoVysledku.getText() + "\n\n" + "Attribut: " + datoveStruktury.jmenaAtributuCil[y] + " Pocet hodnot: " + datoveStruktury.pocetHodnotAtributu[y]);
for (int x = 1; x <= 6; x++) {
if (x == 1) {oknoVysledku.setText(oknoVysledku.getText() + "\n" + "Minimum: " + datoveStruktury.popisStatistika[1][y]);}
if (x == 2) {oknoVysledku.setText(oknoVysledku.getText() + "  " + "Maximum: " + datoveStruktury.popisStatistika[2][y]);}
if (x == 3) {oknoVysledku.setText(oknoVysledku.getText() + "  " + "Mean: " + datoveStruktury.popisStatistika[3][y]);}
if (x == 4) {oknoVysledku.setText(oknoVysledku.getText() + "  " + "Smoch: " + datoveStruktury.popisStatistika[4][y]);}
if (x == 5) {oknoVysledku.setText(oknoVysledku.getText() + "  " + "Mode: " + datoveStruktury.hodnotyModus[y]);}
}
for (int w = 1; w <= datoveStruktury.pocetRadkuSouboru; w++ ) {
if (!datoveStruktury.frekvence[w][y][1].equals("")) {
oknoVysledku.setText(oknoVysledku.getText() + "\n" + " Value " + datoveStruktury.frekvence[w][y][1] + " Frequency " + datoveStruktury.frekvence[w][y][2] + " Rel. frequency " + datoveStruktury.frekvence[w][y][3]);
}
}
}
}
};

class provedAttributeRelevance implements ActionListener {
public void actionPerformed (ActionEvent e) {
AttributeRelevance ar = new AttributeRelevance();
int pocetVybranychAtributu = sp.selectedList.getLastVisibleIndex() + 1;
Object[] vybraneAtributy = sp.selectedModel.getValues();
int y = 0;
for (int z = 0; z < pocetVybranychAtributu; z++) {
 for (int i = 1; i <= datoveStruktury.pocetSloupcuSouboru; i++) {
if ( ((String)vybraneAtributy[z]).equals(datoveStruktury.stavData[1][i])) {
 y = i;
 break;
 }
 }

ar.spocitejAtribut(datoveStruktury.stavData, datoveStruktury.frekvence, datoveStruktury.pocetRadkuSouboru, y, datoveStruktury.typAtributu[1][y], datoveStruktury.pocetHodnotAtributu[y], datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil], datoveStruktury.vybranyCil);
datoveStruktury.attrRelevance = ar.relevance;

}
}
};

class provedSmazatVysledky implements ActionListener {
public void actionPerformed (ActionEvent e) {
oknoVysledku.setText("");
}
};

class provedUlozVysledky implements ActionListener {
public void actionPerformed (ActionEvent e) {
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".txt")||ff.isDirectory();
}
public String getDescription() {
return "*.txt";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".txt");
PrintWriter vystup = new PrintWriter(fw);
oknoVysledku.write(vystup);
}
catch (IOException ee) {
System.out.println ("Output problem");
}

}

}
};

class provedUlozSoubor implements ActionListener {
public void actionPerformed (ActionEvent e) {
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
vystup.print("" + datoveStruktury.stavData[x][y] + ";");
}
vystup.println();
}
vystup.close();
}
catch (IOException ee) {
System.out.println ("Output problem");
}

}

}
};

class provedUlozVybraneSloupce implements ActionListener {
public void actionPerformed (ActionEvent e) {
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
int pocetVybranychAtributu = sp.selectedList.getLastVisibleIndex() + 1;
Object[] vybraneAtributy = sp.selectedModel.getValues();

for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {

for (int z = 0; z < pocetVybranychAtributu; z++) {
if ( ((String)vybraneAtributy[z]).equals(datoveStruktury.stavData[1][y])) {
vystup.print("" + datoveStruktury.stavData[x][y] + ";");
}
}
}
vystup.println();

}
vystup.close();
}
catch (IOException ee) {
System.out.println ("Output problem");
}

}

}
};

class provedUlozVybraneRadky implements ActionListener {
public void actionPerformed (ActionEvent e) {

int prvniObj = 0;
int posledniObj = 0;
try {
prvniObj = Integer.parseInt(tfVyber1.getText());
posledniObj = Integer.parseInt(tfVyber2.getText());
if ((prvniObj < 1) || (posledniObj < 1) ) {
tfVyber1.setText("");
tfVyber2.setText("");
JOptionPane.showMessageDialog(null, "Wrong value in From or To field! Please, enter integer value > 0!", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
}
catch (NumberFormatException ee) {
JOptionPane.showMessageDialog(null, "Wrong value in From or To field! Please, enter integer value!", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
if (!chbZaradVyrad1.isSelected()) {
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if ((x >= prvniObj && x <= posledniObj) || x==1) {
vystup.print("" + datoveStruktury.stavData[x][y] + ";");
}
}
vystup.println();
}
vystup.close();
}
catch (IOException ee) {
System.out.println ("Output problem");
}
}
}
else {
JFileChooser fc = new JFileChooser();
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
boolean odradkuj = false;
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if (x < prvniObj || x > posledniObj) {
vystup.print("" + datoveStruktury.stavData[x][y] + ";");
odradkuj = true;
}
}
if (odradkuj) {
vystup.println();
odradkuj = false;
}
}
vystup.close();
}
catch (IOException ee) {
System.out.println ("Output problem");
}
}
}



}
};

class provedAktivujVyberRadku implements ActionListener {
public void actionPerformed (ActionEvent e) {
labelPanelVyberu.setText("Choose rows");
labelVyber1.setText("From");
labelVyber1.setEnabled(true);
labelVyber2.setText("To");
labelVyber2.setEnabled(true);
tfVyber1.setEnabled(true);
tfVyber2.setEnabled(true);
tlacUlozVybraneRadky.setEnabled(true);
tlacSplitting.setEnabled(false);
chbZaradVyrad1.setText("Exclude rows");
}
};

class provedSplitting implements ActionListener {
public void actionPerformed (ActionEvent e) {
int opakuj = 0;
try {
opakuj = Integer.parseInt(tfVyber3.getText());
}
catch (NumberFormatException eee) {
JOptionPane.showMessageDialog(null, "Wrong number in field Repeat!", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
if (opakuj < 1) {
opakuj = 1;
}
for (int opakuj1 = 1; opakuj1 <= opakuj; opakuj1++) {
int relativne = 0;
int absolutne = 0;
try {
if (!tfVyber1.getText().equals("")) {
relativne = Integer.parseInt(tfVyber1.getText());
}
if (!tfVyber2.getText().equals("")) {
absolutne = Integer.parseInt(tfVyber2.getText());
}
}
catch (NumberFormatException ee) {
JOptionPane.showMessageDialog(null, "Wrong input! Please, enter integer value!", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}
datoveStruktury.dataTrenovaci = new String[datoveStruktury.pocetRadkuSouboru+1][datoveStruktury.pocetSloupcuSouboru+1];
datoveStruktury.dataTestovaci = new String[datoveStruktury.pocetRadkuSouboru+1][datoveStruktury.pocetSloupcuSouboru+1];

if (absolutne > 0 && !chbZaradVyrad1.isSelected()) {
int pocetDatCelkem = datoveStruktury.pocetRadkuSouboru;
int pocetDatTrenink = absolutne;
double podilDatTrenink = (double)pocetDatTrenink/pocetDatCelkem;
pocetDatTrenink = 0;
for (int x = 2; x <= pocetDatCelkem; x++ ) {
double nahodneCislo = Math.random();
if ((nahodneCislo < podilDatTrenink) && (pocetDatTrenink < absolutne )) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[x][y] = datoveStruktury.stavData[x][y];
}
pocetDatTrenink++;
}
else {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTestovaci[x][y] = datoveStruktury.stavData[x][y];
}

}

}
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[1][y] = datoveStruktury.stavData[1][y];
datoveStruktury.dataTestovaci[1][y] = datoveStruktury.stavData[1][y];
}

}

else if (absolutne > 0  && chbZaradVyrad1.isSelected()){
int pocetDatCelkem = datoveStruktury.pocetRadkuSouboru;
int pocetDatTrenink = absolutne;
int pocetDatTrenink1[][] = new int [datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil] +1][3];
double podilDatTrenink = (double)pocetDatTrenink/pocetDatCelkem;
int sumaTrenink = 0;
for (int i = 1; i <= datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil]; i++){ 
pocetDatTrenink1[i][1] = (int)Math.round(Double.parseDouble(datoveStruktury.frekvence[i][datoveStruktury.vybranyCil][2]) * podilDatTrenink);
sumaTrenink = sumaTrenink + pocetDatTrenink1[i][1];
}
System.out.println("dat bude" + sumaTrenink + "zvoleno abs " + absolutne);
pocetDatTrenink = 0;
for (int x = 2; x <= pocetDatCelkem; x++ ) {
int cilNaRadkuX = 0;
for (int i = 1; i <= datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil]; i++){ 
if (datoveStruktury.stavData[x][datoveStruktury.vybranyCil].equals(datoveStruktury.frekvence[i][datoveStruktury.vybranyCil][1])) {
cilNaRadkuX = i;
}
}
double nahodneCislo = Math.random();
if ((nahodneCislo < podilDatTrenink) && (pocetDatTrenink < absolutne ) && pocetDatTrenink1[cilNaRadkuX][1] < pocetDatTrenink1[cilNaRadkuX][2]) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[x][y] = datoveStruktury.stavData[x][y];
}
pocetDatTrenink++;
pocetDatTrenink1[cilNaRadkuX][2]++;
}
else {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTestovaci[x][y] = datoveStruktury.stavData[x][y];
}

}

}
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[1][y] = datoveStruktury.stavData[1][y];
datoveStruktury.dataTestovaci[1][y] = datoveStruktury.stavData[1][y];
}


}

else if (relativne > 0  && !chbZaradVyrad1.isSelected()){
double pocetDatTreninkAbsolutne = Math.round(datoveStruktury.pocetRadkuSouboru * relativne);
double podilDatTrenink = (double)relativne/100;
double pocetDatTrenink = 0;
for (int x = 2; x <= datoveStruktury.pocetRadkuSouboru; x++ ) {
double nahodneCislo = Math.random();
if ((nahodneCislo < podilDatTrenink) && (pocetDatTrenink < pocetDatTreninkAbsolutne )) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[x][y] = datoveStruktury.stavData[x][y];
}
pocetDatTrenink++;
}
else {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTestovaci[x][y] = datoveStruktury.stavData[x][y];
}
}
}
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[1][y] = datoveStruktury.stavData[1][y];
datoveStruktury.dataTestovaci[1][y] = datoveStruktury.stavData[1][y];
}
}

else if (relativne > 0  && chbZaradVyrad1.isSelected()){
double pocetDatTreninkAbsolutne = Math.round(datoveStruktury.pocetRadkuSouboru * relativne);
int pocetDatTrenink1[] = new int [datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil] +1];
double podilDatTrenink = (double)relativne/100;
int sumaTrenink = 0;
for (int i = 1; i <= datoveStruktury.pocetHodnotAtributu[datoveStruktury.vybranyCil]; i++){ 
pocetDatTrenink1[i] = (int)Math.round(Double.parseDouble(datoveStruktury.frekvence[i][datoveStruktury.vybranyCil][2]) * podilDatTrenink);
sumaTrenink = sumaTrenink + pocetDatTrenink1[i];
}
System.out.println("dat bude" + sumaTrenink + "zvoleno abs " + pocetDatTreninkAbsolutne);
int pocetDatTrenink = 0;
for (int x = 2; x <= datoveStruktury.pocetRadkuSouboru; x++ ) {
double nahodneCislo = Math.random();
if ((nahodneCislo < podilDatTrenink) && (pocetDatTrenink < pocetDatTreninkAbsolutne )) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[x][y] = datoveStruktury.stavData[x][y];
}
pocetDatTrenink++;
}
else {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTestovaci[x][y] = datoveStruktury.stavData[x][y];
}

}

}
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++ ) {
datoveStruktury.dataTrenovaci[1][y] = datoveStruktury.stavData[1][y];
datoveStruktury.dataTestovaci[1][y] = datoveStruktury.stavData[1][y];
}


}

else {
JOptionPane.showMessageDialog(null, "There is something wrong with the input...", "Wrong input", JOptionPane.INFORMATION_MESSAGE);
}

JFileChooser fc = new JFileChooser();
fc.setDialogTitle("Uloz trenovaci data");
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

int stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
boolean odradkuj = false;
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if (datoveStruktury.dataTrenovaci[x][y] != null) {
vystup.print("" + datoveStruktury.dataTrenovaci[x][y] + ";");
odradkuj = true;
}
}
if (odradkuj) {
vystup.println();
odradkuj = false;
}
}
vystup.close();
}
catch (IOException ee) {
System.out.println ("Chyba na vystupu souboru");
}
}

//JFileChooser fc = new JFileChooser();
fc.setDialogTitle("Save test data");
fc.setFileFilter(new FileFilter() {
public boolean accept(File ff) {
return ff.getName().toLowerCase().endsWith(".csv")||ff.isDirectory();
}
public String getDescription() {
return "*.csv";
}
});
fc.setAcceptAllFileFilterUsed(false);

stavVyberu = fc.showSaveDialog(f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
try {
FileWriter fw = new FileWriter(fc.getSelectedFile() + ".csv");
PrintWriter vystup = new PrintWriter(fw);
boolean odradkuj = false;
for (int x = 1; x <= datoveStruktury.pocetRadkuSouboru; x++) {
for (int y = 1; y <= datoveStruktury.pocetSloupcuSouboru; y++) {
if (datoveStruktury.dataTestovaci[x][y] != null) {
vystup.print("" + datoveStruktury.dataTestovaci[x][y] + ";");
odradkuj = true;
}
}
if (odradkuj) {
vystup.println();
odradkuj = false;
}
}
vystup.close();
}
catch (IOException ee) {
System.out.println ("Output problem");
}
}

}
}
};

class provedAktivujSplitting implements ActionListener {
public void actionPerformed (ActionEvent e) {
labelPanelVyberu.setText("Data splitting");
labelVyber1.setText("Relative");
labelVyber1.setEnabled(true);
labelVyber2.setText("Absolute");
labelVyber2.setEnabled(true);
labelVyber3.setText("Repeat");
labelVyber3.setEnabled(true);
tfVyber1.setEnabled(true);
tfVyber2.setEnabled(true);
tfVyber3.setText("1");
tfVyber3.setEnabled(true);
tlacSplitting.setEnabled(true);
tlacUlozVybraneRadky.setEnabled(false);
chbZaradVyrad1.setText("Stratified division");
}
};

class provedAttributeDependence implements ActionListener {
public void actionPerformed (ActionEvent e) {

AttributeDependence ad = new AttributeDependence();
ad.dependence();


}
};

} // class    

/*
public DataKapsa datoveStruktury;
static Frame f;
static JTextArea oknoVysledku;

JButton tlacNactiSoubor;
JButton tlacVaha;
JButton tlacCil;
JButton tlacDataDescription;
JButton tlacNoiseEvaluation;
JButton tlacAttributeRelevance;
JButton tlacAttributeDependance;
JButton tlacObjectSelection;
JButton tlacAttributeSelectionRucne;
JButton tlacAttributeSelectionARev;
JButton tlacAttributeSelectionADep;
JButton tlacDataSplitting;
JButton tlacDataSampling;
JButton tlacDiscretization;
JButton tlacGrouping;
JButton tlacHandlingMissingValues;
JButton tlacObjSlctOK;
JButton tlacDataSplitOK;
JButton tlacDiscrOK;
JButton tlacZobrazDD;
JButton tlacZobrazAR;
JButton tlacZobrazAD;
JButton tlacZobrazNoise;
JButton tlacUlozDD;
JButton tlacUlozAR;
JButton tlacUlozAD;
JButton tlacUlozNoise;
JButton tlacDataSamplOK;
JButton tlacASAROK;
JButton tlacASADOK;
JButton tlacASRucOK;
JButton tlacSmazatVysledky;
JButton tlacCilOK;
JButton tlacObjSlctVybratHodnotu;
JButton tlacObjSlctDalsiKomb;
JButton tlacObjSlctVybratKomb;

JLabel labelASAR;
JLabel labelASAD;
JLabel labelOknoVysledku;
JLabel labelSoubor;
JLabel labelVaha;
JLabel labelCil;
JLabel labelObjSelOD;
JLabel labelObjSelDO;
JLabel labelTrenink;
JLabel labelDiscret;
JLabel labelVATA1;
JLabel labelVATA2;
JLabel labelVATA3;
JLabel labelVATA4;
JLabel labelVATA5;
JLabel labelObjSlctA;
JLabel labelObjSlctH;
JLabel labelDataSplitO;
JLabel labelDiscrInt;
JLabel labelDiscrHV;
JLabel labelDiscrMinObj;

JTextField tfASAR;
JTextField tfASAD;
JTextField tfObjSlctOD;
JTextField tfObjSlctDO;
JTextField tfDataSplit;
JTextField tfDiscr;
JTextField tfDataSamp;
JTextField tfDataSplitOpak;
JTextField tfDiscrMO; 
JTextField tfDiscrHV; 
JTextField tfGrouping;

JCheckBox chbDD;
JCheckBox chbAR;
JCheckBox chbAD;
JCheckBox chbNoise;
CheckboxGroup chbgASAR;
CheckboxGroup chbgObjSlct;
CheckboxGroup chbgDataSamp;
CheckboxGroup chbgDiscr;
CheckboxGroup chbgMissing;
Checkbox chbChi;
Checkbox chbEntropy;
Checkbox chbMutuInf;
Checkbox chbZarad;
Checkbox chbVyrad;
Checkbox chbAbs;
Checkbox chbRel;
Checkbox chbEdist;
Checkbox chbEfreq;
Checkbox chbOstre;
Checkbox chbFuzzy;
Checkbox chbSpojDupl;
Checkbox chbDataSplit;
Checkbox chbDataSampl;
Checkbox chbDataSamplCele;
Checkbox chbMisIgnore;
Checkbox chbMisNevim;
Checkbox chbMisModus;
Checkbox chbMisProporc;
Checkbox chbMisAny;

JComboBox comboDiscr;
JComboBox comboVaha;
JComboBox comboCil;
JComboBox comboObjSlctA;
JComboBox comboObjSlctH;
JComboBox comboDataSampl;
JComboBox comboAD1;
JComboBox comboAD2;
JComboBox comboAD3;


JPanel p;
JPanel g;

    



public void makeLayout() {
f = new Frame("System pro predzpracovani dat dataminingovych uloh");
f.addWindowListener(new WindowAdapter () {
public void windowClosing (WindowEvent e) {
System.exit(0);
}
});

f.setLayout(new GridBagLayout());




tlacNactiSoubor = new JButton("Nacteni souboru");
makeComponent(f, tlacNactiSoubor, 0, 0, 1, 1, 0.0, 0.0);
tlacNactiSoubor.addActionListener(new provedNacteniSouboru());
tlacVaha = new JButton("Vaha");
makeComponent(f, tlacVaha, 0, 1, 1, 1, 0.0, 0.0);
tlacVaha.addActionListener(new provedVaha());
tlacCil = new JButton("Cil");
makeComponent(f, tlacCil, 0, 2, 1, 1, 0.0, 0.0);
tlacCil.addActionListener(new provedCil());
tlacDataDescription = new JButton("Data description");
makeComponent(f, tlacDataDescription, 0, 3, 1, 1, 0.0, 0.0);
tlacDataDescription.addActionListener(new provedDataDescription());
tlacNoiseEvaluation = new JButton("Noise evaluation");
makeComponent(f, tlacNoiseEvaluation, 0, 5, 1, 1, 0.0, 0.0);
tlacAttributeRelevance = new JButton("Atribute relevance");
makeComponent(f, tlacAttributeRelevance, 0, 4, 1, 1, 0.0, 0.0);
tlacAttributeRelevance.addActionListener(new provedAttributeRelevance());
tlacAttributeDependance = new JButton("Atribute dependance");
makeComponent(f, tlacAttributeDependance, 0, 7, 1, 1, 0.0, 0.0);
tlacAttributeDependance.addActionListener(new provedAttributeDependance());
tlacObjectSelection = new JButton("Usek objektu");
makeComponent(f, tlacObjectSelection, 0, 10, 1, 1, 0.0, 0.0);
tlacObjectSelection.addActionListener(new provedObjectSelection());
tlacAttributeSelectionRucne = new JButton("Atribute selection - rucne");
makeComponent(f, tlacAttributeSelectionRucne, 9, 0, 1, 1, 0.0, 0.0);
tlacAttributeSelectionRucne.addActionListener(new provedAttributeSelectionRucne());
tlacAttributeSelectionARev = new JButton("Atribute selection - dle ARev");
makeComponent(f, tlacAttributeSelectionARev, 6, 1, 1, 1, 0.0, 0.0);
tlacAttributeSelectionADep = new JButton("Atribute selection - dle ADep");
makeComponent(f, tlacAttributeSelectionADep, 6, 5, 1, 1, 0.0, 0.0);
tlacDataSplitting = new JButton("Data splitting");
makeComponent(f, tlacDataSplitting, 0, 17, 1, 1, 0.0, 0.0);
tlacDataSampling = new JButton("Data sampling");
makeComponent(f, tlacDataSampling, 0, 29, 1, 1, 0.0, 0.0);
tlacDiscretization = new JButton("Discretization");
tlacDataSampling.addActionListener(new provedDataSampl());
makeComponent(f, tlacDiscretization, 0, 21, 1, 1, 0.0, 0.0);
tlacGrouping = new JButton("Grouping");
makeComponent(f, tlacGrouping, 9, 7, 1, 1, 0.0, 0.0);
tlacHandlingMissingValues = new JButton("Missing values");
makeComponent(f, tlacHandlingMissingValues, 5, 10, 1, 1, 0.0, 0.0);
tlacObjSlctOK = new JButton("OK");
makeComponent(f, tlacObjSlctOK, 2, 10, 1, 1, 0.0, 0.0);
tlacObjSlctOK.addActionListener(new provedObjSlctOK());
tlacDataSplitOK = new JButton("OK");
makeComponent(f, tlacDataSplitOK, 1, 17, 1, 1, 0.0, 0.0);
tlacDiscrOK = new JButton("OK");
makeComponent(f, tlacDiscrOK, 1, 21, 1, 1, 0.0, 0.0);
tlacZobrazDD = new JButton("Zobrazit");
makeComponent(f, tlacZobrazDD, 2, 3, 1, 1, 0.0, 0.0);
tlacZobrazDD.addActionListener(new provedZobrazDD());
tlacZobrazAR = new JButton("Zobrazit");
makeComponent(f, tlacZobrazAR, 2, 4, 1, 1, 0.0, 0.0);
tlacZobrazAR.addActionListener(new provedZobrazAR());
tlacZobrazAD = new JButton("Zobrazit");
makeComponent(f, tlacZobrazAD, 2, 7, 1, 1, 0.0, 0.0);
tlacZobrazNoise = new JButton("Zobrazit");
makeComponent(f, tlacZobrazNoise, 2, 5, 1, 1, 0.0, 0.0);
tlacUlozDD = new JButton("Ulozit");
makeComponent(f, tlacUlozDD, 3, 3, 1, 1, 0.0, 0.0);
tlacUlozDD.addActionListener(new provedUlozDD());
tlacUlozAR = new JButton("Ulozit");
makeComponent(f, tlacUlozAR, 3, 4, 1, 1, 0.0, 0.0);
tlacUlozAD = new JButton("Ulozit");
makeComponent(f, tlacUlozAD, 3, 7, 1, 1, 0.0, 0.0);
tlacUlozNoise = new JButton("Ulozit");
makeComponent(f, tlacUlozNoise, 3, 5, 1, 1, 0.0, 0.0);
tlacDataSamplOK = new JButton("OK");
makeComponent(f, tlacDataSamplOK, 1, 29, 1, 1, 0.0, 0.0);
tlacDataSamplOK.addActionListener(new provedDataSamplOK());
tlacASAROK = new JButton("OK");
makeComponent(f, tlacASAROK, 7, 1, 1, 1, 0.0, 0.0);
tlacASADOK = new JButton("OK");
makeComponent(f, tlacASADOK, 7, 5, 1, 1, 0.0, 0.0);
tlacASADOK.addActionListener(new provedASADOK());
tlacASRucOK = new JButton("OK");
makeComponent(f, tlacASRucOK, 11, 0, 1, 1, 0.0, 0.0);
tlacSmazatVysledky = new JButton("Vycistit okno");
makeComponent(f, tlacSmazatVysledky, 5, 31, 1, 1, 0.0, 0.0);
tlacSmazatVysledky.addActionListener(new provedSmazatVysledky());
tlacCilOK = new JButton("OK");
makeComponent(f, tlacCilOK, 4, 2, 1, 1, 0.0, 0.0);
tlacCilOK.addActionListener(new provedCilOK());
tlacObjSlctVybratHodnotu = new JButton("Vybrat hodnotu");
makeComponent(f, tlacObjSlctVybratHodnotu, 2, 14, 1, 1, 0.0, 0.0);
tlacObjSlctVybratHodnotu.addActionListener(new provedObjSlctVybratHodnotu());
tlacObjSlctDalsiKomb = new JButton("Dalsi kombinace");
makeComponent(f, tlacObjSlctDalsiKomb, 2, 15, 1, 1, 0.0, 0.0);
tlacObjSlctDalsiKomb.addActionListener(new provedObjSlctDalsiKomb());
tlacObjSlctVybratKomb = new JButton("Kombinace objektu");
makeComponent(f, tlacObjSlctVybratKomb, 1, 10, 1, 1, 0.0, 0.0);
tlacObjSlctVybratKomb.addActionListener(new provedObjSlctVybratKomb());

labelASAR = new JLabel(" nejlepsich dle");
makeComponent(f, labelASAR, 7, 2, 1, 1, 0.0, 0.0);
labelASAD = new JLabel(" nejlepsich");
makeComponent(f, labelASAD, 7, 6, 1, 1, 0.0, 0.0);
labelOknoVysledku = new JLabel("Okno vysledku");
makeComponent(f, labelOknoVysledku, 5, 14, 1, 1, 0.0, 0.0);
labelSoubor = new JLabel("Soubor: ");
makeComponent(f, labelSoubor, 1, 0, 5, 1, 0.0, 0.0);
labelVaha = new JLabel("Vaha: "); 
makeComponent(f, labelVaha, 1, 1, 1, 1, 0.0, 0.0);
labelCil = new JLabel("Cil: ");  
makeComponent(f, labelCil, 1, 2, 1, 1, 0.0, 0.0);
labelObjSelOD = new JLabel("Od radku: ");  
makeComponent(f, labelObjSelOD, 0, 12, 1, 1, 0.0, 0.0);
labelObjSelDO = new JLabel("Do radku: ");
makeComponent(f, labelObjSelDO, 0, 13, 1, 1, 0.0, 0.0);
labelTrenink = new JLabel("% trenovacich");
makeComponent(f, labelTrenink, 1, 18, 1, 1, 0.0, 0.0);
labelDiscret = new JLabel(" Atribut ");  
makeComponent(f, labelDiscret, 0, 24, 1, 1, 0.0, 0.0);
labelObjSlctA = new JLabel(" Atribut ");  
makeComponent(f, labelObjSlctA, 0, 14, 1, 1, 0.0, 0.0);
labelObjSlctH = new JLabel(" Hodnota ");  
makeComponent(f, labelObjSlctH, 0, 15, 1, 1, 0.0, 0.0);
labelDataSplitO = new JLabel(" Pocet opakovani");  
makeComponent(f, labelDataSplitO, 1, 19, 1, 1, 0.0, 0.0);
labelDiscrInt = new JLabel("Intervalu");  
makeComponent(f, labelDiscrInt, 1, 25, 1, 1, 0.0, 0.0);
labelDiscrMinObj = new JLabel(" Min. objektu");  
makeComponent(f, labelDiscrMinObj, 1, 26, 1, 1, 0.0, 0.0);
labelDiscrHV = new JLabel(" Hladina vyzn.");  
makeComponent(f, labelDiscrHV, 1, 27, 1, 1, 0.0, 0.0);



labelVATA1 = new JLabel("                          ");  
makeComponent(f, labelVATA1, 0, 9, 1, 1, 0.0, 0.0);
labelVATA2 = new JLabel("                          ");  
makeComponent(f, labelVATA2, 0, 16, 1, 1, 0.0, 0.0);
labelVATA3 = new JLabel("                          ");  
makeComponent(f, labelVATA3, 0, 20, 1, 1, 0.0, 0.0);
labelVATA4 = new JLabel("                          ");  
makeComponent(f, labelVATA4, 0, 28, 1, 1, 0.0, 0.0);
//labelVATA5 = new JLabel("                          ");  
//makeComponent(f, labelVATA5, 0, 30, 1, 1, 0.0, 0.0);


oknoVysledku = new JTextArea();
JScrollPane posuvnik = new JScrollPane(oknoVysledku);
makeComponent(f, posuvnik, 4, 15, 8, 16, 0.0, 0.0);
p = new JPanel();
makeComponent(f, p, 9, 1, 3, 6, 0.0, 0.0);
p.setLayout(new BorderLayout());
g = new JPanel();
makeComponent(f, g, 9, 8, 3, 6, 0.0, 0.0);
g.setLayout(new BorderLayout());


tfASAR = new JTextField(15);
makeComponent(f, tfASAR, 6, 2, 1, 1, 0.0, 0.0);
tfASAD = new JTextField(15);
makeComponent(f, tfASAD, 6, 6, 1, 1, 0.0, 0.0);
tfObjSlctOD = new JTextField(15);
makeComponent(f, tfObjSlctOD, 1, 12, 1, 1, 0.0, 0.0);
tfObjSlctDO = new JTextField(15);
makeComponent(f, tfObjSlctDO, 1, 13, 1, 1, 0.0, 0.0);
tfDataSplit = new JTextField(15);
makeComponent(f, tfDataSplit, 0, 18, 1, 1, 0.0, 0.0);
tfDataSplitOpak = new JTextField(15);
makeComponent(f, tfDataSplitOpak, 0, 19, 1, 1, 0.0, 0.0);
tfDiscr = new JTextField(15);
makeComponent(f, tfDiscr, 0, 25, 1, 1, 0.0, 0.0);
tfDiscrMO = new JTextField(15);
makeComponent(f, tfDiscrMO, 0, 26, 1, 1, 0.0, 0.0);
tfDiscrHV = new JTextField(15);
makeComponent(f, tfDiscrHV, 0, 27, 1, 1, 0.0, 0.0);
tfDataSamp = new JTextField(15);
makeComponent(f, tfDataSamp, 2, 29, 1, 1, 0.0, 0.0);
tfGrouping = new JTextField(15);
makeComponent(f, tfGrouping, 9, 14, 1, 1, 0.0, 0.0);


chbDD = new JCheckBox("Provedeno");
makeComponent(f, chbDD, 1, 3, 1, 1, 0.0, 0.0);
chbDD.setEnabled(false);
chbAR = new JCheckBox("Provedeno");
makeComponent(f, chbAR, 1, 4, 1, 1, 0.0, 0.0);
chbAR.setEnabled(false);
chbAD = new JCheckBox("Provedeno");
makeComponent(f, chbAD, 1, 7, 1, 1, 0.0, 0.0);
chbAD.setEnabled(false);
chbNoise = new JCheckBox("Provedeno");
makeComponent(f, chbNoise, 1, 5, 1, 1, 0.0, 0.0);
chbNoise.setEnabled(false);
CheckboxGroup chbgASAR = new CheckboxGroup();
CheckboxGroup chbgObjSlct = new CheckboxGroup();
CheckboxGroup chbgDataSamp = new CheckboxGroup();
CheckboxGroup chbgDiscr = new CheckboxGroup();
CheckboxGroup chbgMissing = new CheckboxGroup();
chbChi = new Checkbox("Chi     ", chbgASAR, false);
makeComponent(f, chbChi, 8, 3, 1, 1, 0.0, 0.0);
chbEntropy = new Checkbox("Entropy", chbgASAR, true);
makeComponent(f, chbEntropy, 7, 3, 1, 1, 0.0, 0.0);
chbMutuInf = new Checkbox("Mutual information", chbgASAR, false);
makeComponent(f, chbMutuInf, 6, 3, 1, 1, 0.0, 0.0);
chbZarad = new Checkbox("Zarad", chbgObjSlct, true);
makeComponent(f, chbZarad, 0, 11, 1, 1, 0.0, 0.0);
chbVyrad = new Checkbox("Vyrad", chbgObjSlct, false);
makeComponent(f, chbVyrad, 1, 11, 1, 1, 0.0, 0.0);
chbAbs = new Checkbox("Absolutne", chbgDataSamp, false);
makeComponent(f, chbAbs, 0, 30, 1, 1, 0.0, 0.0);
chbRel = new Checkbox("Relativne", chbgDataSamp, true);
makeComponent(f, chbRel, 1, 30, 1, 1, 0.0, 0.0);
chbEdist = new Checkbox("Ekvidistani", chbgDiscr, true);
makeComponent(f, chbEdist, 0, 22, 1, 1, 0.0, 0.0);
chbEfreq = new Checkbox("Ekvifrekvencni", chbgDiscr, false);
makeComponent(f, chbEfreq, 1, 22, 1, 1, 0.0, 0.0);
chbOstre = new Checkbox("Ostre", chbgDiscr, false);
makeComponent(f, chbOstre, 0, 23, 1, 1, 0.0, 0.0);
chbFuzzy = new Checkbox("Fuzzy", chbgDiscr, false);
makeComponent(f, chbFuzzy, 1, 23, 1, 1, 0.0, 0.0);
chbSpojDupl = new Checkbox("Spojit duplicity");
makeComponent(f, chbSpojDupl, 2, 11, 1, 1, 0.0, 0.0);
chbDataSplit = new Checkbox("Zachovat pomer trid");
makeComponent(f, chbDataSplit, 2, 18, 1, 1, 0.0, 0.0);
chbDataSampl = new Checkbox("Zachovat pomer trid");
makeComponent(f, chbDataSampl, 0, 31, 1, 1, 0.0, 0.0);
chbDataSamplCele = new Checkbox("Pouzit celou tridu");
makeComponent(f, chbDataSamplCele, 1, 31, 1, 1, 0.0, 0.0);
chbMisIgnore = new Checkbox("Ignoruj", chbgMissing, true);
makeComponent(f, chbMisIgnore, 5, 11, 1, 1, 0.0, 0.0);
chbMisNevim = new Checkbox("Nevim", chbgMissing, false);
makeComponent(f, chbMisNevim, 6, 11, 1, 1, 0.0, 0.0);
chbMisModus = new Checkbox("Nejcetnejsi", chbgMissing, false);
makeComponent(f, chbMisModus, 7, 11, 1, 1, 0.0, 0.0);
chbMisProporc = new Checkbox("Proporcionalne", chbgMissing, false);
makeComponent(f, chbMisProporc, 5, 12, 1, 1, 0.0, 0.0);
chbMisAny = new Checkbox("Libovolna", chbgMissing, false);
makeComponent(f, chbMisAny, 6, 12, 1, 1, 0.0, 0.0);


comboVaha = new JComboBox();
makeComponent(f, comboVaha, 2, 1, 2, 1, 0.0, 0.0);
comboCil = new JComboBox();
makeComponent(f, comboCil, 2, 2, 2, 1, 0.0, 0.0);
comboDiscr = new JComboBox();
makeComponent(f, comboDiscr, 1, 24, 1, 1, 0.0, 0.0);
comboObjSlctA = new JComboBox();
makeComponent(f, comboObjSlctA, 1, 14, 1, 1, 0.0, 0.0);
comboObjSlctH = new JComboBox();
makeComponent(f, comboObjSlctH, 1, 15, 1, 1, 0.0, 0.0);
comboDataSampl = new JComboBox();
makeComponent(f, comboDataSampl, 2, 31, 1, 1, 0.0, 0.0);
comboAD1 = new JComboBox();
makeComponent(f, comboAD1, 0, 8, 1, 1, 0.0, 0.0);
comboAD2 = new JComboBox();
makeComponent(f, comboAD2, 1, 8, 1, 1, 0.0, 0.0);
comboAD3 = new JComboBox();
makeComponent(f, comboAD3, 2, 8, 1, 1, 0.0, 0.0);

 
f.pack();
f.setVisible(true);

}

  void makeComponent(Container cont, Object arg, int x, int y, int w, int h, double weightx, double weighty) {
GridBagLayout gbl = (GridBagLayout)cont.getLayout();
GridBagConstraints c = new GridBagConstraints();
Component comp;

c.fill = GridBagConstraints.BOTH;
c.gridx = x;
c.gridy = y;
c.gridwidth = w;
c.gridheight = h;
c.weightx = weightx;
c.weighty = weighty;
if (arg instanceof String) {
comp = new Button((String)arg);
}
else {
comp = (Component)arg;
}
cont.add(comp);
gbl.setConstraints(comp, c);
} // makeComponent

void setKomponentyOknaNotAccessible() {

tlacVaha.setEnabled(false);
tlacCil.setEnabled(false);
tlacDataDescription.setEnabled(false);
tlacNoiseEvaluation.setEnabled(false);
tlacAttributeRelevance.setEnabled(false);
tlacAttributeDependance.setEnabled(false);
tlacObjectSelection.setEnabled(false);
tlacAttributeSelectionRucne.setEnabled(false);
tlacAttributeSelectionARev.setEnabled(false);
tlacAttributeSelectionADep.setEnabled(false);
tlacDataSplitting.setEnabled(false);
tlacDataSampling.setEnabled(false);
tlacDiscretization.setEnabled(false);
tlacGrouping.setEnabled(false);
tlacHandlingMissingValues.setEnabled(false);
tlacObjSlctOK.setEnabled(false);
tlacDataSplitOK.setEnabled(false);
tlacDiscrOK.setEnabled(false);
tlacZobrazDD.setEnabled(false);
tlacZobrazAR.setEnabled(false);
tlacZobrazAD.setEnabled(false);
tlacZobrazNoise.setEnabled(false);
tlacUlozDD.setEnabled(false);
tlacUlozAR.setEnabled(false);
tlacUlozAD.setEnabled(false);
tlacUlozNoise.setEnabled(false);
tlacDataSamplOK.setEnabled(false);
tlacASAROK.setEnabled(false);
tlacASADOK.setEnabled(false);
tlacASRucOK.setEnabled(false);
tlacCilOK.setEnabled(false);
tlacObjSlctVybratHodnotu.setEnabled(false);
tlacObjSlctDalsiKomb.setEnabled(false);
tlacObjSlctVybratKomb.setEnabled(false);

tfASAR.setEnabled(false);
tfASAD.setEnabled(false);
tfObjSlctOD.setEnabled(false);
tfObjSlctDO.setEnabled(false);
tfDataSplit.setEnabled(false);
tfDiscr.setEnabled(false);
tfDataSamp.setEnabled(false);
tfDataSplitOpak.setEnabled(false);
tfDiscrMO.setEnabled(false);
tfDiscrHV.setEnabled(false);


chbDD.setEnabled(false);
chbAR.setEnabled(false);
chbAD.setEnabled(false);
chbNoise.setEnabled(false);
chbChi.setEnabled(false);
chbEntropy.setEnabled(false);
chbMutuInf.setEnabled(false);
chbZarad.setEnabled(false);
chbVyrad.setEnabled(false);
chbAbs.setEnabled(false);
chbRel.setEnabled(false);
chbEdist.setEnabled(false);
chbEfreq.setEnabled(false);
chbOstre.setEnabled(false);
chbFuzzy.setEnabled(false);
chbSpojDupl.setEnabled(false);
chbDataSplit.setEnabled(false);
chbDataSampl.setEnabled(false);
chbDataSamplCele.setEnabled(false);

comboVaha.setEnabled(false);
comboCil.setEnabled(false);
comboDiscr.setEnabled(false);
comboObjSlctA.setEnabled(false);
comboObjSlctH.setEnabled(false);
comboDataSampl.setEnabled(false);

Grafika.oknoVysledku.setText("Napoveda k programu: Nejprve pomoci tlacitka vlevo nahore vyberte soubor, se kterym budete pracovat. ");
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + "Dale zvolte vahu a cilovy atribut a stisknete OK. ");
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + "Pote budou aktivovana dalsi tlacitka. Jejich stisknuti aktivuje prislusnou oblast. ");
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + "Prislusna procedura je pak provedena po stisku tlacitka OK. " + "\n\n\n");
}

class provedNacteniSouboru implements ActionListener {
public void actionPerformed (ActionEvent e) {
NactiCSVSoubor csvSoubor = new NactiCSVSoubor();
datoveStruktury = datoveStruktury.getInstance();
JFileChooser fc = new JFileChooser();
int stavVyberu = fc.showOpenDialog(Grafika.f);
if (stavVyberu == JFileChooser.APPROVE_OPTION) {
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + "Byl vybran soubor "+ fc.getCurrentDirectory().toString() + "\\" + fc.getSelectedFile().getName());
Grafika.oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" );
csvSoubor.nacti(""+ fc.getCurrentDirectory().toString() +  "\\" + fc.getSelectedFile().getName());
//csvSoubor.isAttributeNumeric();
datoveStruktury.stavData = csvSoubor.getStav();
datoveStruktury.pocetRadkuSouboru = csvSoubor.getPocetRadku();
datoveStruktury.pocetSloupcuSouboru = csvSoubor.getPocetSloupcu();
oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n");
tlacVaha.setEnabled(true);
labelSoubor.setText("Soubor: "+ fc.getCurrentDirectory().toString() +  "\\" + fc.getSelectedFile().getName());
}
}
};

class provedVaha implements ActionListener {
public void actionPerformed (ActionEvent e) {
datoveStruktury.zjistiAtributy();
comboVaha.removeAllItems();
int pocetSloupcu = datoveStruktury.sloupceVaha;
for (int i = 0; i< pocetSloupcu; i++) {
comboVaha.addItem(datoveStruktury.jmenaAtributuVaha[i]);
}
comboVaha.setEnabled(true);
tlacCil.setEnabled(true);

}
};

class provedCil implements ActionListener {
public void actionPerformed (ActionEvent e) {
tlacCilOK.setEnabled(true);
comboCil.removeAllItems();
int pocetSloupcu = datoveStruktury.sloupce;
String vybranaVaha = (String)comboVaha.getSelectedItem();
for (int i = 0; i<= pocetSloupcu; i++) {
if (!datoveStruktury.jmenaAtributuCil[i].equals(vybranaVaha)) {
comboCil.addItem(datoveStruktury.jmenaAtributuCil[i]);
}
}
comboCil.setEnabled(true);

}
};

class provedCilOK implements ActionListener {
public void actionPerformed (ActionEvent e) {
if (comboCil.getSelectedItem().equals("vyberte")) {
JOptionPane.showMessageDialog(null, "Vyberte cilovy atribut!", "Nebyl vybran cilovy atribut", JOptionPane.INFORMATION_MESSAGE);
}
if (!comboCil.getSelectedItem().equals("vyberte")) {
tlacDataDescription.setEnabled(true);
oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + "Vahou je atribut " + comboVaha.getSelectedItem() + "\n" + "Cilem je atribut " + comboCil.getSelectedItem());
}

String cilS = comboCil.getSelectedItem().toString();
for (int y = 0; y <= datoveStruktury.sloupce; y++) {
if (datoveStruktury.jmenaAtributuCil[y].equals(cilS)) {
datoveStruktury.cilZvoleny = y;
}
}
}
};

class provedDataDescription implements ActionListener {
public void actionPerformed (ActionEvent e) {
DataDescription dataDes = new DataDescription();
dataDes.popis(datoveStruktury.stavData, datoveStruktury.radky, datoveStruktury.sloupce, comboVaha.getSelectedIndex() );

oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + "Data Description provedeno  ");
datoveStruktury.frekvence = dataDes.getFrekvence();
datoveStruktury.popisStatistika = dataDes.getVysledkyPopisStat();
datoveStruktury.pocetHodnot = dataDes.getPocetHodnot();
tlacZobrazDD.setEnabled(true);
//tlacUlozDD.setEnabled(true);
chbDD.setSelected(true);
tlacDataDescription.setEnabled(true);
tlacNoiseEvaluation.setEnabled(true);
tlacAttributeRelevance.setEnabled(true);
tlacAttributeDependance.setEnabled(true);
tlacObjectSelection.setEnabled(true);
tlacAttributeSelectionRucne.setEnabled(true);
tlacDataSplitting.setEnabled(true);
tlacDataSampling.setEnabled(true);
tlacDiscretization.setEnabled(true);
tlacGrouping.setEnabled(true);
tlacHandlingMissingValues.setEnabled(true);
tlacObjSlctVybratKomb.setEnabled(true);
}
};

class provedZobrazDD implements ActionListener {
public void actionPerformed (ActionEvent e) {
int sloupcu = datoveStruktury.sloupce;
int radku = datoveStruktury.radky;
for (int y = 1; y <= sloupcu; y++) {
oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n\n" + "Atribut: " + datoveStruktury.jmenaAtributuCil[y] + " Pocet hodnot: " + datoveStruktury.pocetHodnot[y]);
for (int x = 1; x <= 6; x++) {
if (x == 1) {oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + "Minimum: " + datoveStruktury.popisStatistika[1][y]);}
if (x == 2) {oknoVysledku.setText(Grafika.oknoVysledku.getText() + "  " + "Maximum: " + datoveStruktury.popisStatistika[2][y]);}
if (x == 3) {oknoVysledku.setText(Grafika.oknoVysledku.getText() + "  " + "Prumer: " + datoveStruktury.popisStatistika[3][y]);}
if (x == 4) {oknoVysledku.setText(Grafika.oknoVysledku.getText() + "  " + "Smerodatna odchylka: " + datoveStruktury.popisStatistika[4][y]);}
if (x == 5) {oknoVysledku.setText(Grafika.oknoVysledku.getText() + "  " + "Modus - hodnoty s frekvenci: " + datoveStruktury.popisStatistika[5][y]);}
}
for (int w = 1; w <= radku; w++ ) {
if (!datoveStruktury.frekvence[w][y][1].equals("")) {
oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + " Hodnota " + datoveStruktury.frekvence[w][y][1] + " Cetnost " + datoveStruktury.frekvence[w][y][2] + " Rel.cetnost " + datoveStruktury.frekvence[w][y][3]);
}
}
}
}
};

class provedUlozDD implements ActionListener {
public void actionPerformed (ActionEvent e) {

}
};

class provedAttributeRelevance implements ActionListener {
public void actionPerformed (ActionEvent e) {
AttributeRelevance ar = new AttributeRelevance();
ar.spocitejAtribut(datoveStruktury.cilZvoleny, datoveStruktury.frekvence, datoveStruktury.stavData, datoveStruktury.radky, datoveStruktury.sloupce, datoveStruktury.pocetHodnot);
datoveStruktury.attrRelevance = ar.relevance;
tlacAttributeSelectionARev.setEnabled(true);
tlacZobrazAR.setEnabled(true);
chbAR.setSelected(true);
}
};

class provedZobrazAR implements ActionListener {
public void actionPerformed (ActionEvent e) {
AttributeRelevance ar = new AttributeRelevance();
ar.spocitejAtribut(datoveStruktury.cilZvoleny, datoveStruktury.frekvence, datoveStruktury.stavData, datoveStruktury.radky, datoveStruktury.sloupce, datoveStruktury.pocetHodnot);
datoveStruktury.attrRelevance = ar.relevance;
tlacAttributeSelectionARev.setEnabled(true);
tlacZobrazAR.setEnabled(true);
}
};

class provedAttributeSelectionRucne implements ActionListener {
public void actionPerformed (ActionEvent e) {
Object[] values = datoveStruktury.jmenaAtributuCil;
SelectorPanel sp = new SelectorPanel(values);
p.setBorder(BorderFactory.createLineBorder(Color.black, 1));
p.add(sp);
f.setVisible(true);

tlacASRucOK.setEnabled(true);
}
};

class provedASRucOK implements ActionListener {
public void actionPerformed (ActionEvent e) {

}
};

class provedObjectSelection implements ActionListener {
public void actionPerformed (ActionEvent e) {
tfObjSlctOD.setEnabled(true);
tfObjSlctDO.setEnabled(true);
chbZarad.setEnabled(true);
chbVyrad.setEnabled(true);
//chbSpojDupl.setEnabled(true);
tlacObjSlctOK.setEnabled(true);
comboObjSlctH.setEnabled(false);
tlacObjSlctDalsiKomb.setEnabled(false);
comboObjSlctA.setEnabled(false);
tlacObjSlctVybratHodnotu.setEnabled(false);
}
};

class provedObjSlctOK implements ActionListener {
public void actionPerformed (ActionEvent e) {
int prvniObj = 0;
int posledniObj = 0;
try {
prvniObj = Integer.parseInt(tfObjSlctOD.getText());
posledniObj = Integer.parseInt(tfObjSlctDO.getText());
if ((prvniObj < 1) || (posledniObj < 1) ) {
tfObjSlctOD.setText("");
tfObjSlctDO.setText("");
JOptionPane.showMessageDialog(null, "Spatna hodnota v poli OD nebo DO! Zadejte cele cislo!", "Spatny vstup", JOptionPane.INFORMATION_MESSAGE);
}
}
catch (NumberFormatException ee) {
JOptionPane.showMessageDialog(null, "Spatna hodnota v poli OD nebo DO! Zadejte cele cislo!", "Spatny vstup", JOptionPane.INFORMATION_MESSAGE);
}
if (chbZarad.getState()) {
datoveStruktury.zaraditUsek(prvniObj, posledniObj);
}
else {
datoveStruktury.vyraditUsek(prvniObj, posledniObj);
}
if (chbSpojDupl.getState()) {
//ObjectSelection os = new ObjectSelection();
//os.spojDuplicity(datoveStruktury.vybraneObj, datoveStruktury.vyberObjRadku, datoveStruktury.sloupce, comboVaha.getSelectedIndex());

}
else {
datoveStruktury.stavData = datoveStruktury.vybraneObj;
datoveStruktury.radky = datoveStruktury.vyberObjRadku;
datoveStruktury.vyberObjRadku = 0;
datoveStruktury.frekvence = null;
datoveStruktury.popisStatistika = null;
datoveStruktury.pocetHodnot = null;
DataDescription dataDes = new DataDescription();
dataDes.popis(datoveStruktury.stavData, datoveStruktury.radky, datoveStruktury.sloupce, comboVaha.getSelectedIndex() );

oknoVysledku.setText(Grafika.oknoVysledku.getText() + "\n" + "Data Description provedeno ");
datoveStruktury.frekvence = dataDes.getFrekvence();
datoveStruktury.popisStatistika = dataDes.getVysledkyPopisStat();
datoveStruktury.pocetHodnot = dataDes.getPocetHodnot();
setKomponentyOknaNotAccessible();
tlacNactiSoubor.setEnabled(true);
tlacDataDescription.setEnabled(true);
chbDD.setSelected(false);
tlacVaha.setEnabled(true);
tlacCil.setEnabled(true);
comboCil.setEnabled(true);
comboVaha.setEnabled(true);
}

}
};

class provedDataSampl implements ActionListener {
public void actionPerformed (ActionEvent e) {
tfDataSamp.setEnabled(true);
chbAbs.setEnabled(true);
chbRel.setEnabled(true);
tlacDataSamplOK.setEnabled(true);
chbDataSampl.setEnabled(true);
chbDataSamplCele.setEnabled(true);
for (int y = 1; y <= datoveStruktury.pocetHodnot[datoveStruktury.cilZvoleny]; y++) {
comboDataSampl.addItem(datoveStruktury.frekvence[y][datoveStruktury.cilZvoleny][1]);
}

comboDataSampl.setEnabled(true);




}
};

class provedDataSamplOK implements ActionListener {
public void actionPerformed (ActionEvent e) {
int kolik = 0;
try {
kolik = Integer.parseInt(tfDataSamp.getText());
}
catch (NumberFormatException ee) {
JOptionPane.showMessageDialog(null, "Spatna hodnota! Zadejte cele cislo!", "Spatny vstup", JOptionPane.INFORMATION_MESSAGE);
}
if (((kolik > 99) || (kolik < 1)) && (chbRel.getState())) {
JOptionPane.showMessageDialog(null, "Spatna hodnota! Zadejte cele cislo v rozsahu 1 - 99 nebo zvolte Absolutne!", "Spatny vstup", JOptionPane.INFORMATION_MESSAGE);
}
if (((kolik > (datoveStruktury.radky - 1) ) || (kolik < 1)) && (chbAbs.getState())) {
JOptionPane.showMessageDialog(null, "Spatna hodnota! Zadejte cele cislo v rozsahu 1 - " + (datoveStruktury.radky - 1), "Spatny vstup", JOptionPane.INFORMATION_MESSAGE);
}
datoveStruktury.sample(chbDataSamplCele.getState(), (String) comboDataSampl.getSelectedItem(), chbAbs.getState(), kolik, chbDataSampl.getState());
}
};

class provedObjSlctVybratKomb implements ActionListener {
public void actionPerformed (ActionEvent e) {
int pocetSloupcu = datoveStruktury.sloupce;
String vybranaVaha = (String)comboVaha.getSelectedItem();
for (int i = 1; i<= pocetSloupcu; i++) {
//if (!datoveStruktury.jmenaAtributuCil[i].equals(vybranaVaha)) {
comboObjSlctA.addItem(datoveStruktury.jmenaAtributuCil[i]);
//}
}

comboObjSlctA.setEnabled(true);
tlacObjSlctVybratHodnotu.setEnabled(true);
tfObjSlctOD.setEnabled(false);
tfObjSlctDO.setEnabled(false);
chbZarad.setEnabled(true);
chbVyrad.setEnabled(true);
//chbSpojDupl.setEnabled(true);
tlacObjSlctOK.setEnabled(true);

}
};

class provedObjSlctVybratHodnotu implements ActionListener {
public void actionPerformed (ActionEvent e) {

int x=1;
String hodnota = " ";
System.out.println("combo obsah " + comboObjSlctA.getSelectedIndex());
while (!hodnota.equals("")) {
hodnota = datoveStruktury.frekvence[x][comboObjSlctA.getSelectedIndex()+1][1];
if (!hodnota.equals("")) {
comboObjSlctH.addItem(hodnota);
x++;
}
}

comboObjSlctH.setEnabled(true);
tlacObjSlctDalsiKomb.setEnabled(true);
}
};

class provedObjSlctDalsiKomb implements ActionListener {
public void actionPerformed (ActionEvent e) {

}
};

class provedAttributeDependance implements ActionListener {
public void actionPerformed (ActionEvent e) {
tlacAttributeSelectionADep.setEnabled(true);
}
};

class provedASADOK implements ActionListener {
public void actionPerformed (ActionEvent e) {

}
};

class provedSmazatVysledky implements ActionListener {
public void actionPerformed (ActionEvent e) {
oknoVysledku.setText("");
}
};
*/

